;=======================================================================|
;									|
;		ROM image (0xF0000`0xFFFFF)				|
;			for Wander Swan Total Sound Driver		|
;									|
;					Programmed by			|
;						S.W.			|
;									|
;=======================================================================|
;	IIӁII							|
;									|
;	0xFFF0:0x0000̗̈ɁA						|
;	far jumpAWonderSwanp̃f[^Ȃ̂		|
;	.WS(ROMC[W)t@C̍쐬ɏƁII			|
;									|
;	܂"ROM_IMG.BIN"쐬́ÃIuWFNg擪ɔzu鎖	|
;	x"_Start"A0xF000:0000ɔzu悤ɁI		|
;=======================================================================|

	.186

;=======================================================================|
;				define					|
;=======================================================================|
DISPLAY_MODE_swCOLOR	equ	1	;SW`̃J[ɁI

include	ws.inc				;`t@C@WonderSwan I/O
include	service.inc			;`t@C@荞
include	bank.inc			;`t@C@oN
include	wtd_def.inc			;`t@C@hCo[
include	wtd_ver.inc			;`t@C@o[W

;=======================================================================|
;				Segment define				|
;=======================================================================|
;CODË--------------------------------------------------------------
TEXT		segment byte public 'CODE'	; for LSI-C
TEXT		ends

_TEXT		segment byte public 'CODE'	; for TurboC
_TEXT		ends

_GHOST_DATA	segment para public 'CODE'	;LSI-C86ł͕KvB
_GHOST_DATA	ends				;

;DATÄ@f[^̈--------------------------------------------
	public	dseg_start
DATA		segment para public 'DATA'	; for LSI-C
dseg_start:
DATA		ends


_DATA		segment para public 'DATA'	; for TurboC0
_DATA		ends

;BSS̈@f[^̈-------------------------------------------
	public	bss_start
BSS		segment word public 'DATA'	; for LSI-C
bss_start:
BSS		ends

_BSS		segment word public 'BSS'	; for TurboC
_BSS		ends

;HEAP̈@󂫗̈----------------------------------------------------
	public	heap_start
_HEAP		segment para public 'BSS'
heap_start:
_HEAP		ends

;ZOgEO[v`
CGROUP		group	_TEXT, TEXT
DGROUP		group	_DATA, DATA, BSS, _BSS, _HEAP

		assume	cs:CGROUP, ds:DGROUP, es:DGROUP

;****************************************************************
;*								*
;*			vOER[h			*
;*								*
;****************************************************************
TEXT	segment byte public 'CODE'

;===============================================================|
;			O錾				|
;===============================================================|

	;bmain֐
	extrn	_main			:near	;bmain֐

	;vsc̊֐
	extrn	_WTD_FunctionLoad	:near	;t@NṼ[h
	extrn	_WTD_Work		:near	;p[N

	;̓
	public	_Start				;CPUZbgɌĂ΂
	public	_Exit				;main֐𔲂
	public	_InterruptVector_Default	;荞݃xN^l(reti)
	public	_InterruptVector_DivZero	;OZ荞݃[`

;===============================================================|
;			Start Up				|
;===============================================================|
_Start:	
		cli			;荞ݑSʋ֎~
		cld			;CNg[h

		;-------------------------------
		;ZOg̐ݒ
		mov	ax,IRAM_Segment	;
		mov	es,ax		;
		mov	ss,ax		;SS,ESIRAM̈ʒu

		mov	ax, cs		;
		sub	ax, TEXT	;
		add	ax,_GHOST_DATA	;
		mov	ds, ax		;DSDGROUP̈ʒu

		;-------------------------------
		;X^bNGA̐ݒ
		mov	sp,VramAdrFontColor	;Color FontŌ

		;-------------------------------
		;ς݃f[^̓]
		mov	di, offset DGROUP:dseg_start
		mov	si, di		;
		mov	cx, offset DGROUP:bss_start
		shr	cx, 1		; word alignmented
	rep	movsw			;ꊇ]

		;-------------------------------
		;f[^̂ONA
		xor	ax, ax		;
		mov	di, offset DGROUP:bss_start
		mov	cx, offset DGROUP:heap_start
		sub	cx, di		;
		shr	cx, 1		;
	rep	stosw			;ꊇtB

		;-------------------------------
		;荞݃xNg̐ݒ
		mov	ax,cs		;
		mov	bx,offset CGROUP:_InterruptVector_Default
		mov	di,offset DGROUP:_InteruptVector
		mov	cx,128		;[v
_Start_SetIntVector_Loop1:		;
		mov	es:[di],bx	;
		mov	es:[di+2],ax	;
		add	di,4		;
		loop	_Start_SetIntVector_Loop1

		;-------------------------------
		;荞݂̐ݒ
		mov	ax,0		;
		out	Int_Enable,al	;n[hEFA荞݋֎~

		mov	al,INT_HARDWARE_VECTOR_BASE
		out	Int_Vector,al	;x[XxNgݒ

;foCX̏-------------------------------------------------------
		push	cs			;
		pop	ds			;dscs

		;J[`FbN
		in	al,HARDWARE		;n[hEFAE`FbN
		and	al,HardwareMask		;
		jnz	_run0_color		;

_run0_mono:	;=======[ Normal WonderSwan ]=======
		;-------------------------------
		;Mono Mode
		in	al,LCD_ColorMode	;Mono Mode
		and	al,01Fh			;
		or	al,000h			;
		out	LCD_ColorMode,al	;

		jmp	_run0_common		;

_run0_color:	;=======[ WonderSwan Color ]=======
		;-------------------------------
		;Color Mode
		in	al,LCD_ColorMode	;Packed Mode
		and	al,01Fh			;
		or	al,0E0h			;
		out	LCD_ColorMode,al	;

		;-------------------------------
		;Color Palette
;		mov	si,offset CGROUP:_ColorPalette
		mov	si,offset CGROUP:_ColorFontData
		add	si,0010h		;Color PaletteAddr.
		mov	di,offset DGROUP:VramAdrPalette
		mov	cx,16			;16F
	rep	movsw				;ꊇ]

		;-------------------------------
		;Color Font
;		mov	si,offset CGROUP:_bmp_ASCII_C
		mov	si,offset CGROUP:_ColorFontData
		add	si,0030h		;Color FontAddr.
		mov	di,offset DGROUP:VramAdrFontColor
		mov	cx,128 *8 *2		;n ~ line ~ dd
	rep	movsw				;ꊇ]

		jmp	_run0_common

_run0_common:	;=======[ S@ ʐݒ ]=======

		mov	ax,06420h		;
		out	LCD_Gray0123,ax		;
		mov	ax,0fca8h		;
		out	LCD_Gray4567,ax		;

		;-------------------------------
		;Mono Palette
;		mov	bx,offset CGROUP:_MonoPalette	;
		mov	bx,offset CGROUP:_MonoPalette	;
		mov	ax,cs:[bx]		;
		out	LCD_ScrPalette0,ax	;

		;-------------------------------
		;Mono Font
;		mov	si,offset CGROUP:_MonoPalette	;
		mov	si,offset CGROUP:_MonoFontData	;
		add	si,0010h		;Mono FontAddr.
		mov	di,offset DGROUP:VramAdrFontMono
		mov	cx,128 *8 *1		;n ~ line ~ dw
	rep	movsw				;ꊇ]

		;-------------------------------
		;V-RAM	fill space
		mov	ax,00020h		;Xy[X
		mov	di,offset DGROUP:VramAdrScreen1
		mov	cx,32*32		;32~32LN^
	rep	stosw				;ꊇtB

	;V-RAMAhXݒ
	mov	al,(VramAdrSprite/512)
	out	LCD_SpriteArea,al
	mov	al,(VramAdrScreen1 / 2048) + ((VramAdrScreen2 / 2048) * 16)
	out	LCD_ScreenArea,al

	mov	ax,LCD_DispCtrl_Scr1 + LCD_DispCtrl_Spr
	out	LCD_DisplayControl,ax	;display_control(0005h);

	xor	ax,ax			;ax  0x0000
	out	LCD_SpriteStart,al	;sprite_set_range(0,0);
	out	LCD_SpriteCount,al	;
	out	LCD_Scr1Scroll,ax	;screen_set_scroll(SCREEN1, 0, 0);
	out	LCD_Scr2Scroll,ax	;screen_set_scrol2(SCREEN2, 0, 0);
	out	LCD_Scr2WindowsStart,ax	;
	out	LCD_SprWindowsStart,ax	;
	mov	ax,0FFFFh		;ax  0xFFFF
	out	LCD_Scr2WindowsEnd,ax	;screen2_set_window(0, 0, 255, 255);
	out	LCD_SprWindowsEnd,ax	;sprite_set_window(0, 0, 255, 255);

		;-------------------------------
		;DSDGROUP
		mov	ax,IRAM_Segment
		mov	ds,ax
		mov	es,ax

		;-------------------------------
		;荞݋
		sti

		;-------------------------------
		;bmain֐Ăяo
		call	_main
_Exit:

		;-------------------------------
		;vOI
_Loop:		cli			;荞݋֎~
		hlt			;CPU~
		jmp	_Loop		;[v

;===============================================================|
;			荞ݐ̏ݒl			|
;===============================================================|
_InterruptVector_Default:
	iret
;===============================================================|
;			OZ荞				|
;===============================================================|
_InterruptVector_DivZero:
	iret

;****************************************************************
;*								*
;*			ROMɂf[^Q			*
;*								*
;****************************************************************
;===============================================================|
;			tHg				|
;===============================================================|
_ColorFontData:
include		ASCII_C.ASM		;J[tHg

_MonoFontData:
include		ASCII_M.ASM		;mNtHg

_MonoPalette:
	dw	07503h		;Black	Black2	White	BG

;===============================================================|
TEXT	ends
;****************************************************************
;*								*
;*			f[^Q				*
;*								*
;****************************************************************
DATA	segment para public 'DATA'

	public	_InteruptVector		;荞݃xN^
_InteruptVector:			;荞݃xN^foCXp
	dd	128	dup	(0)	;0x0180́AFe[u
					;0x0000`0x01FF


DATA	ends

;===============================================================|
;BSS̈@f[^̈-------------------------------------------
BSS		segment word public 'DATA'
INITSIZE:
BEGINBSS:
BSS		ends

_BSS		segment word public 'BSS'
_BSS		ends

;HEAP̈@󂫗̈----------------------------------------------------
_HEAP		segment para public 'BSS'
ENDBSS:
BEGINHEAP:
_HEAP		ends

;****************************************************************
	end	_Start
