/****************************************************************/
/*																*/
/*					Music Viewer	Display Sub Routine			*/
/*						for Wonder Swan Emulator				*/
/*																*/
/*								Programmed by.					*/
/*									Fun-X						*/
/*									S.W.						*/
/*																*/
/****************************************************************/
/*--------------------------------------*/
/*	萔`							*/
/*--------------------------------------*/

/*Text\p */
#define LCDclsChr			0x00		// LCDNAp̃LN^
#define	PalText				0			// eLXg\ppbgԍ
#define	PalBG				1			// L[{[hppbgԍ
#define	PalSprite			12			// XvCgppbgԍ
#define	TextAscii			0x7f		// AsciiR[h̍ől
#define PAL(x)				(x<<9)		// pbgw}N

/*--------------------------------------*/
/*	O[oϐ`					*/
/*--------------------------------------*/
// Text\p̃pbgf[^
/*	ROM_BIOS.ASMŒ`܂B(S.W.)
int	TextPaletteData[] = {
	0x0000,0x0700,0x0070,0x0007, 0x0077,0x0707,0x0770,0x777,
	0x0000,0x000F,0x00F0,0x00FF, 0x000F,0x0F0F,0x000F,0xFFF
};
*/

/*VRAM Address*/
	VRAM_Sprite		far	*VramSprite  = VramAdrSprite;
	VRAM_Screen		far	*VramScreen1 = VramAdrScreen1;
	VRAM_Screen		far	*VramScreen2 = VramAdrScreen2;
	VRAM_FontColor	far	*VramFont    = VramAdrFontColor;
	VRAM_Palatte	far *VramPalette = VramAdrPalette;

/*--------------------------------------------------------------*/
/*	\													*/
/*--------------------------------------------------------------*/
/*	int	x		\ x W						*/
/*			int	y		\ y W						*/
/*			char *str	\B						*/
/*Ԓl	int			ŌɎgpLN^[ + 1			*/
/*	Screen1̎w肵Wɕ\B			*/
/*J	S.W.												*/
/*--------------------------------------------------------------*/
int	print(int x,int y,char *str){
	int		lstr = 0;					/* p̃|C^ */
	int		cChr;						/* LN^[R[hp */

	while(cChr = str[lstr++]){			/* ͍Ōł邩`FbN */
		VramScreen1->Atr[y][x++] = cChr;};
	return	cChr;						/* ݒ̃tHgԍ */
};
/*--------------------------------------------------------------*/
/*	ʂ̃NA												*/
/*--------------------------------------------------------------*/
/*	cChr	ߐsLN^[ (pbg͂O)		*/
/*Ԓl													*/
/*	ʑŜcChrŖߐsB						*/
/*J	S.W.												*/
/*--------------------------------------------------------------*/
void LCDcls(int cChr)
{

	int	x,y;							/* ʃNAp */

	for(x=0;x<LCD_ScrWidth;x++){
		for(y=0;y<LCD_ScrHight;y++){
			VramScreen1->Atr[y][x] = cChr;
/*			XN[PgȂ̂ŁARgAEg܂B(S.W.)	*/
/*			VramScreen2->Atr[y][x] = cChr;		*/
		};
	};
};


/*--------------------------------------------------------------*/
/*	tHgf[^o^											*/
/*--------------------------------------------------------------*/
/*	int nStartNo	o^tHg̊Jnԍ			*/
/*			int nNum		o^						*/
/*			char *cData		f[^|C^						*/
/*Ԓl													*/
/*	nStartNonNumtHgf[^o^			*/
/*J	Fun-X												*/
/*--------------------------------------------------------------*/
void SetFontData(int nStartNo,int nNum,const char *cData)
{
	int i,j;

    for(j=0;j<nNum;j++)
	    for(i=0;i<LCD_FontSize;i++)
			VramFont->PCG[nStartNo+j][i] = cData[j*LCD_FontSize+i];

}
/*--------------------------------------------------------------*/
/*	`
/*--------------------------------------------------------------*/
/*	int nScreen		`悷XN[(0or1)			*/
/*			int x			`JnXW					*/
/*			int y			`JnYW					*/
/*			int w			`敝n							*/
/*			int h			`捂							*/
/*			int nFontNo		`JntHgԍ			*/
/*			int nPalNo		pbgԍ						*/
/*Ԓl													*/
/*	Dataɕ`                                      */
/*J	Fun-X												*/
/*--------------------------------------------------------------*/
void BGDraw(int nScreen,int x,int y,int w,int h,int *Data,int nFontNo,int nPalNo)
{

	int i,j;

	for(j=0;j<h;j++){	
		for(i=0;i<w;i++){	
			VramScreen1->Atr[j+y][i+x] = nFontNo+Data[j*w+i]|PAL(nPalNo);
		}
	}
	

}

/*--------------------------------------------------------------*/
/*	Օ\													*/
/*--------------------------------------------------------------*/
/*													*/
/*Ԓl													*/
/*	Ղ\										*/
/*J	Fun-X												*/
/*--------------------------------------------------------------*/
void DrawInit(void)
{
	int i,j,k;
	

	// S
	BGDraw(0,0,0,LOGO_X,LOGO_Y,mapLogo,FONT_LOGO,KEYBOARD_PAL_NO);
	// 
	for(j=0;j<4;j++){
		for(i=0;i<2;i++){
			BGDraw(0,i*7,j*4+3,KEYBOARD_X,KEYBOARD_Y,mapKeyboard,FONT_KEYBOARD,KEYBOARD_PAL_NO);
		}
	}

	// p
	j=2;
	for(i=0;i<4;i++)
		BGDraw(0,5,i*4+2,1,1,&j,FONT_PANPOT,KEYBOARD_PAL_NO);
	// CH
	for(i=0;i<4;i++){
		BGDraw(0,0,i*4+2,2,1,&mapCH[i],FONT_CH,KEYBOARD_PAL_NO);
	}
    // t[
	for(i=0;i<4;i++){
		BGDraw(0,15,i*4+2,13,4,&mapFrame,0,1);
	}

    // 
	for(i=0;i<3;i++){
		BGDraw(0,i*4+6,0,3,2,&mapButton,FONT_BUTTON,KEYBOARD_PAL_NO);
	}

	print(24,0,"TIME");
	
	VramSprite->Atr[8].x=56;
	VramSprite->Atr[8].y=3;
	VramSprite->Atr[9].x=56+32;
	VramSprite->Atr[9].y=3;
	VramSprite->Atr[10].x=56+64;
	VramSprite->Atr[10].y=3;
	
	if(nStatus){
		VramSprite->Atr[8].Atr=FONT_PATTERN|PAL(4);
		VramSprite->Atr[9].Atr=FONT_PATTERN+4|PAL(4);
		VramSprite->Atr[10].Atr=FONT_PATTERN+5|PAL(4);
	}
	else{
		VramSprite->Atr[8].Atr=FONT_PATTERN+3|PAL(4);
		VramSprite->Atr[9].Atr=FONT_PATTERN+4|PAL(4);
		VramSprite->Atr[10].Atr=FONT_PATTERN+2|PAL(4);
	}
	


}
/*--------------------------------------------------------------*/
/*															*/
/*--------------------------------------------------------------*/
/*													*/
/*Ԓl													*/
/*	Palette0eLXgpɐݒ肷B					*/
/*			16FJ[[hɂB							*/
/*J	S.W.												*/
/*			Fun-X												*/
/*--------------------------------------------------------------*/
void LCDinit()
{

	// ėpϐ
	int	i;

//	// J[[h̐ݒ
//	"ROM_BIOS.ASM"ŁA@𔻕ʂĂɍ킹ݒ܂B(S.W.)
//	outb(LCD_ColorMode,
//		 COLOR_MODE_16PACKED | (LCD_ColorModeMask & inb(LCD_ColorMode)) );


//	// LN^[0𓧖Fɂ
//		"ROM_BIOS.ASM"ŁAXA^ȃtHg`Ă܂B(S.W.)
//	for(i=0;i<LCD_FontSize;i++){
//		VramFont->PCG[LCDclsChr][i] = 0;
//	}

	// tHgpbgݒ
	for(i=0;i<LCD_Color;i++){
//		"ROM_BIOS.ASM"ŁAẽpbgݒ肵܂B(S.W.)
//		VramPalette->Color[0][i] = TextPaletteData[i]; */ // eLXgp
		VramPalette->Color[PalBG][i] = sPal4[i];              // L[{[hp
		VramPalette->Color[PalSprite][i] = sPal4[i];             // XvCgp
	}                           

	//---ȉtHgo^n--------------------

	// L[{[h
	SetFontData(FONT_KEYBOARD,FONT_USE_KEYBOARD,grpKeyboard);
	// S
	SetFontData(FONT_LOGO,FONT_USE_LOGO,grpLogo);
	// p
	SetFontData(FONT_PANPOT,FONT_USE_PANPOT,grpPan);
	// Q[W
	SetFontData(FONT_LENGTH,FONT_USE_LENGTH,grpLength);
	// {[Q[W
	SetFontData(FONT_VOL,FONT_USE_VOL,grpVol);
	// CH
	SetFontData(FONT_CH,FONT_USE_CH,grpCH);
	// t[
	SetFontData(3,9,grpFrame);

	// XvCg
	SetFontData(FONT_SPR,FONT_USE_SPR,grpSpr);

	// {^
	SetFontData(FONT_BUTTON,FONT_USE_BUTTON,grpButton);
	// t
	SetFontData(FONT_PATTERN,FONT_USE_PATTERN,grpPattern);

	// XvCg0`10\
	outb(LCD_SpriteStart,0);
	outb(LCD_SpriteCount,11);
	for(i=0;i<11;i++){
		VramSprite->Atr[i].x=8*30;
		VramSprite->Atr[i].y=8*30;
	}

	// ʂ̃NA
	LCDcls(LCDclsChr);



};


