/****************************************************************/
/*																*/
/*					Music Viewer								*/
/*						for Wonder Swan Emulator				*/
/*																*/
/*								Programmed by.					*/
/*									Fun-X						*/
/*									S.W.						*/
/*																*/
/****************************************************************/
/*--------------------------------------*/
/*	萔`							*/
/*--------------------------------------*/
#define DISPLAY_MODE_swCOLOR			/* S.W. ݌vBIOSݒ*/

#include <stdio.h>
#include <wtd.h>
#include "ws.h"		/* IO Device`t@C */
#include "grp.h"

static int nStatus=2;  /* tԁEOIɏɒu*/

/*	Tu[`Q	*/
#include "rom_disp.c"
#include "rom_key.c"
#include "rom_time.c"
#include "debug.c"

/*--------------------------------------*/
/*	O[oϐ`					*/
/*--------------------------------------*/
static	WtdIL	wtdIL;			/*̂āAwtdILɂ̐擪AhXB*/
static	char near *wtdBUFF;		/*AhXϐƂĎB*/
static	char near *wtdBUFF_Sys;
static	char near *wtdBUFF_Pcm;
static	char near *wtdBUFF_Ch0;
static	char near *wtdBUFF_Emb;
static	Wtd *WtdState[4];
static	Wtd_Sys *WtdSys;
static	WTD_Mus *WtdMus;

/*--------------------------------------*/
/*	O錾							*/
/*--------------------------------------*/
//	O.objt@CɂO[oϐ
extern	char	WTD_Work[WTD_WorkSize_H];

//	O.objt@Cɂ֐
extern	void	WTD_FunctionLoad(WtdIL	near	*Wtd_Function);

/*--------------------------------------*/
/*	vg^Cv錾					*/
/*--------------------------------------*/
/*	ʕ\	*/
void	LCDcls(int cChr);
void	LCDinit();
int		print(int x,int y,char *str);

/*	L[	*/
int		Inkey0();
int		KeyWait();

/*	vsc֘A	*/
void	WTD_FunctionLoad(WtdIL	near	*Wtd_Function);

// VBLANK҂ǂ
/*
void VSyncWait(void)
{
	int i;
	i = inw(TIMER_CounterV);

	while(i==inw(TIMER_CounterV)){
	}

}
*/
/*--------------------------------------------------------------*/
/*	C[`												*/
/*--------------------------------------------------------------*/
/*													*/
/*Ԓl													*/
/*	rA[G悷郋[`						*/
/*			KA[vƂ邱ƁB						*/
/*J	Fun-X												*/
/*			S.W.												*/
/*--------------------------------------------------------------*/
void main(){
	int		count;
	int		j,k,l,key;
	static int i=0;
	// \pobt@
	char szBuf[16];

    // Ke[u
	const char szNote[12][3]={"c","c#","d","d#","e","f","f#","g","g#","a","a#","b"};
	// KXvCg̕\e[u
	const int nKeyOn[]={0,2,4,6,8,12,14,16,18,20,22,24};
    // Q[We[u쐬p
	int nGage[8]={0,0,0,0,0,0,0,0};
	// fobO[h
	static char nDebug=0;
	// ^CJEgۑp
	static char cLastSec=0,cLastMin=0;

/*p[NAhX̎擾 */
	wtdBUFF 	= WTD_Work;		/*zϐł́A擪̃AhX*/
	wtdBUFF_Sys	= wtdBUFF + WTD_WorkAdd_System;
	wtdBUFF_Pcm	= wtdBUFF + WTD_WorkAdd_PCM;
	wtdBUFF_Ch0	= wtdBUFF + WTD_WorkAdd_Ch0;
	wtdBUFF_Emb	= wtdBUFF + WTD_WorkAdd_Emb;

	WtdSys = (Wtd_Sys*)wtdBUFF_Sys;
	WtdMus = (WTD_Mus*)0xE0000000L;

/*ʕ\*/
	LCDinit();
	LCDcls(0x0020);

/* IL֐̃[h	*/
	WTD_FunctionLoad(&wtdIL);

//			nDebug=debug_main(); //I0Ԃ

/* WTDݒ	*/
	wtdIL.Stay();

	// L[{[h\
	DrawInit();

	// Xe[^XAhX擾CH\
    for(i=0;i<4;i++){
		WtdState[i]=(Wtd*)(wtdBUFF + WTD_WorkAdd_Ch0 + i * WTD_WorkChSize);
    }

/*tJn*/
	count = wtdIL.MusicPlay(0xE0000000L);

	Time_Init();

	while(1){

		/*	[v	*/
        key=KeyHit();


		// STARTfobO[hI
		if(key==KEY_START)
			nDebug=1;

        // fobO[h
        if(nDebug){
			nDebug=debug_main(); //I0Ԃ
		}
		// r[A[{
		else{
			// ~
			if(key&KEY_B){
				wtdIL.MusicStop();
				// {^ύX
				VramSprite->Atr[10].Atr=FONT_PATTERN+2|PAL(4);
				VramSprite->Atr[8].Atr=FONT_PATTERN+3|PAL(4);
				// Xe[^XύX
				nStatus=0;
			}
			// Đ
			if(key&KEY_A){
				wtdIL.MusicPlay(0xE0000000L);
				// {^ύX
				VramSprite->Atr[8].Atr=FONT_PATTERN|PAL(4);
				VramSprite->Atr[9].Atr=FONT_PATTERN+4|PAL(4);
				VramSprite->Atr[10].Atr=FONT_PATTERN+5|PAL(4);
				// ^C}[
				Time_Init();
				// Xe[^XύX
				nStatus=2;
			}

		    // Xe[^X\
		    for(i=0;i<4;i++){
//---------- ȉK----------
				k=i*2;

			    count=WtdState[i]->KeySet[0];	//KeyKeySet[0]֕ύX(S.W.)
				
			
				// x
				if(count==255){
					sprintf(szBuf,"o-r  ");
					// XvCg͉ʂ̊O
					VramSprite->Atr[k].x = VramSprite->Atr[k+1].x = 240;
					VramSprite->Atr[k].x = VramSprite->Atr[k+1].y = 240;
				}
				else{
					// IN^[u
					//l=WtdState[i]->Octave;
					l=(count/12)-1;		//KeySet[0]vZɕύX(S.W.)
					// c`b𔻕
					//count=WtdState[i]->KeySet[0];		//Ɉړ
					//j%=12
					j=(count%12);		//KeySet[0]vZɕύX(S.W.)
					// IN^[u1`8Ă鎞݈̂
					if(l>0 && l<9){
						// IN^[uƉK
						sprintf(szBuf,"o%d%-2s",l,szNote[j]);
	                	l--;
						// ȂXvCg\
						if(count!=255){
							// Օ\̃XvCgWݒ
							VramSprite->Atr[k].Atr = mapKeyOn[j][0] | PAL(4);
							VramSprite->Atr[k].x = (nKeyOn[j]+(l*28))%112;
							VramSprite->Atr[k].y = (k<<4)+36-((l>>2)*12);
						
							VramSprite->Atr[k+1].Atr = mapKeyOn[j][1]|PAL(4);
							VramSprite->Atr[k+1].x = VramSprite->Atr[k].x;
							VramSprite->Atr[k+1].y = VramSprite->Atr[k].y+8;
						}
						else{
							// XvCg͉ʂ̊O
							VramSprite->Atr[k].x = VramSprite->Atr[k+1].x = 240;
							VramSprite->Atr[k].x = VramSprite->Atr[k+1].y = 240;
						}

	                }
					// \ΏۊO
					else{
						sprintf(szBuf,"----");
						// XvCg͉ʂ̊O
						VramSprite->Atr[k].x = VramSprite->Atr[k+1].x = 240;
						VramSprite->Atr[k].x = VramSprite->Atr[k+1].y = 240;
					}
				}
				k=i*4;
	            // `
		        print(2,k+2,szBuf);
//---------- ȉLengthQ[W----------
				l=WtdState[i]->LengCounter;
				// 128ȏ127
				if(l>127) l=127;
				for(j=0;j<(l>>4);j++)
					nGage[j]=4;
				nGage[j]=((l>>2)&3)+1;
				j++;
				for(j;j<8;j++)
					nGage[j]=0;
				BGDraw(0,7,k+2,8,1,nGage,FONT_LENGTH,KEYBOARD_PAL_NO);
//---------- ȉVolQ[W----------
				// Ƃ肠101̒lŕ\(͈0`12)
				l=WtdState[i]->ExprSet/10;
				for(j=0;j<(l>>2);j++)
					nGage[2-j]=4;
				nGage[2-j]=(l&3);
				j++;
				for(j;j<3;j++)
					nGage[2-j]=0;
				BGDraw(0,14,k+3,1,3,nGage,FONT_VOL,KEYBOARD_PAL_NO);
//---------- ȉpƃ{[ --------------
				l=WtdState[i]->Pan;

				sprintf(szBuf,"v%03d p%03d",WtdState[i]->Expr,l);
		        print(16,k+4,szBuf);

				// 0`31 
				if(l<32)
					l=0;
				// 32`55 
				else if(l>=32 && l<56)
					l=1;
				// 56`71 
				else if(l>=56 && l<72)
					l=2;
				// 72`96 E
				else if(l>=72 && l<=96)
					l=3;
				// 97`127 E
				else if(l>96)
					l=4;

				BGDraw(0,6,k+2,1,1,&l,FONT_PANPOT,KEYBOARD_PAL_NO);

//---------- ȉ̑ ----------

	            // FƃfB`[
				sprintf(szBuf,"@%03d D%-5d",WtdState[i]->Program,WtdState[i]->BendDetune);
		        print(16,k+3,szBuf);
				// Q[g^C
				sprintf(szBuf,"Q%03d q%-5d",WtdState[i]->GateTime8,WtdState[i]->GateTimeStepLast);
		        print(16,k+5,szBuf);
			}

//			VsyncWait();
			// VBLANKǂ
			// OɊ֐ƂȂȂ
			i=inw(TIMER_CounterV);
			while(i==inw(TIMER_CounterV)){};

		}
		// t
		if(nStatus){
			sprintf(szBuf,"%02d:%02d",TimeCount.cMin,TimeCount.cSec);
			// Ƃ܂ԕۑ
			cLastSec=TimeCount.cSec;
			cLastMin=TimeCount.cMin;
		}
		else{
			sprintf(szBuf,"%02d:%02d",cLastMin,cLastSec);
		}
		print(23,1,szBuf);

	};

};
