;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				MML Compiler Program			|
;				Heder Compile Routine			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;===============================================================|
;		FX\́íj				|
;===============================================================|
.data
FX		db	23h,21h,77h,73h	;#!ws
		db	60	Dup(0FFh)
FX_filename	db	16	dup(0)	;t@C
FX_title	db	24	dup(0)	;^Cg
FX_fileadr	dd	0FFFFFFFFh	;t@C̃AhXB
FX_filesize	dd	?		;t@CTCY
FX_block	dw	?		;ubN
FX_mode		dw	0006h		;[h
FX_data		dd	?		;NE
FX_type		dd	000000000h	;t@C̎
FX_resouce	dd	0FFFFFFFFh	;\[ẌʒuB

;===============================================================|
;		tO						|
;===============================================================|
cHCD_FlagFx	db	00h		;tO FXt@C

;===============================================================|
;								|
;===============================================================|
.const
c_Head_Com_Adrs		dw	((offset c_Head_Com_Adr_E)-(offset c_Head_Com_Adr_S))/2 + 1
c_Head_Com_Adr_S	dw	offset cHCD_0		;TB
			dw	offset cHCD_1		;PA
			dw	offset cHCD_2		;FX
			dw	offset cHCD_3		;TI
			dw	offset cHCD_4		;FI
			dw	offset cHCD_5		;IN
			dw	offset cHCD_6		;#timebase
			dw	offset cHCD_7		;#part
			dw	offset cHCD_8		;#version
			dw	offset cHCD_9		;#Switch
			dw	offset cHCD_10		;#title
			dw	offset cHCD_11		;#filename
c_Head_Com_Adr_E	dw	offset cHCD_12		;#include
;---------------------------------------------------------------|
;	@R}h					|
;		Ō24hŏI				|
;	Ao͂ꏊ						|
;	    00h	I						|
;	    1xh	CS	vO				|
;		x	Segment		0:CS / 1:DS(WTD) / 2:ES(MML)
;		word	Offset		Offset Address		|
;		byte	Output Type	00h:Byte / 01:Word	|
;					20h:+24h		|
;	    F0h	vO					|
;		nnnn	Offset Address				|
;---------------------------------------------------------------
cHCD_0	db	0dh,0ah,'TB',24h, 011h	;Seg = WTD
	dw	WTD_Mus_TimeBase	;Time base
	db	00h,00h			;Byte , End
cHCD_1	db	0dh,0ah,'PA',24h, 011h	;Seg = WTD
	dw	WTD_Mus_Part		;Music Part count
	db	00h,00h			;Byte , End
cHCD_2	db	0dh,0ah,'FX',24h, 010h	;Seg = CS
	dw	offset cHCD_FlagFx	;FX File Make
	db	00h,00h			;Byte , End
cHCD_3	db	0dh,0ah,'TI',24h, 0f0h	;
	dw	offset cHCD_Set_title	;
	db	00h			;
cHCD_4	db	0dh,0ah,'FI',24h, 0f0h	;
	dw	offset cHCD_Set_filename
	db	00h			;
cHCD_5	db	0dh,0ah,'IN',24h, 0f0h	;
	dw	offset cHCD_include	;
	db	00h			;
cHCD_6	db	'#timebase',24h, 11h	;Seg = WTD
	dw	WTD_Mus_TimeBase	;Time base
	db	00h,00h			;Byte , End
cHCD_7	db	'#part',24h, 11h	;Seg = WTD
	dw	WTD_Mus_Part		;Music Part count
	db	00h,00h			;Byte , End
cHCD_8	db	'#version',24h, 11h	;Seg = WTD
	dw	WTD_Mus_Version + 0	;Music Version
	db	00h,11h			;Seg = WTD
	dw	WTD_Mus_Version + 1	;Music Version
	db	00h,00h			;Byte , End
cHCD_9	db	'#switch',24h, 10h	;Seg = CS
	dw	cHCD_FlagFx		;FX File Make
	db	00h,00h			;Byte , End
cHCD_10	db	'#title',24h, 0f0h	;
	dw	offset cHCD_Set_title	;
	db	00h			;
cHCD_11	db	'#filename',24h, 0f0h	;
	dw	offset cHCD_Set_filename;
	db	00h			;
cHCD_12	db	'#include',24h, 0f0h	;
	dw	offset cHCD_include	;
	db	0			;
.code
;---------------------------------------------------------------
;	
;---------------------------------------------------------------
cHCD_Set_Loop	proc	near	uses ax cx di,
		szBuff:word,
		ptBuff:word

	.repeat
	  call	cread_l			;󔒂̃`FbN
	.until	(al>=21h)
	dec	cs:[pMML_File]		;|C^EfBNg

	;s`FbN
	mov	cx,szBuff
	mov	di,ptBuff
	.repeat
		call	cread_l			;ahf[^
		dec	cs:[pMML_File]		;|C^EfBNg
		.break	.if	(al == 0dh)

		;]
		mov	cs:[di],al		;̓]
		inc	di			;
	;	stosb

		;`FbN
		inc	cs:[pMML_File]		;|C^ECNg
	.untilcxz

	ret				;
cHCD_Set_Loop	endp
;---------------------------------------------------------------
;	
;---------------------------------------------------------------
cHCD_Set_title		proc	near

	invoke	cHCD_Set_Loop,	24,	addr FX_title

	ret
cHCD_Set_title	endp		;
;---------------------------------------------------------------
;	
;---------------------------------------------------------------
cHCD_Set_filename	proc	near

	invoke	cHCD_Set_Loop,	16,	addr FX_filename

	ret
cHCD_Set_filename	endp		;
;---------------------------------------------------------------|
;		CN[ht@C̑}			|
;---------------------------------------------------------------|
cHCD_include	proc	near	uses	ds es

	local	cFilename[128]:BYTE	;

	pusha

	;-----------------------
	;t@C܂Ń|C^i܂B
	.repeat
	    CALL	CREAD_L		;
	.until	(al>20h)		;QÕR[h͔΂

	;-----------------------
	;t@C̎擾
	dec	CS:[pMML_File]		;
	xor	di,di			
	mov	cx,128			;
	.repeat				;
	   CALL	CREAD_L			;
	   .break  .if	(al==00dh)	;si[I
	   mov	cFilename[di],al	;
	   inc	di			;
	.untilcxz			;
	mov	cFilename[di],0		;
	inc	di			;
	mov	cFilename[di],0dh	;
	inc	di			;
	mov	cFilename[di],0ah	;
	inc	di			;
	mov	cFilename[di],24h	;
	CALL	CREAD_L			;|C^i܂

	;-----------------------
	;t@CEI[v
	invoke	Memory_Open,0800h	;m
	mov	ds,ax			;
	invoke	File_Open,	addr ss:cFilename,0	;CN[ht@CEI[v
	push	ax			;nhۑ
	invoke	File_Load,	ax,addr ds:0		;CN[ht@CE[h
	mov	cx,ax			;cxCN[ht@CTCY
	pop	ax			;axnh
	invoke	File_Close,	ax	;CN[ht@CEN[Y


	;-----------------------
	;MMLt@CACN[ht@C炷
	push	cx			;
	push	ds			;
	STD				;ubN]fBNg
	mov	ax, cs:[segMml_File]	;
	mov	bx, cs:[szMml_File]	;MMLŌ
	mov	ds, ax			;
	lea	si, [bx - 1]		;ds:si = ]
	mov	es, ax			;
	lea	di, [bx - 1]		;es:di = ]
	add	di, cx			;
	mov	cx, bx			;
	sub	cx, CS:[pMML_File]	;cx = ]
	rep	MOVSB			;
	pop	ds			;
	pop	cx			;

	;-----------------------
	;CN[ht@C̑}
	push	cx			;
	CLD				;ubN]CNg
	xor	si,si			;DS:SI ]
	MOV	es,CS:[segMml_File]	;
	MOV	di,CS:[pMML_File]	;ES:DI 
	REP	MOVSB			;ubN]
	pop	cx			;

	;-----------------------
	;EOF
	DEC	DI			;
	.if	(byte ptr es:[di]==01ah)
		MOV	byte ptr es:[di],020h	;
	.endif

	;-----------------------
	;TCY傫B
	add	CS:[szMml_File],cx	;

	;-----------------------
	;蓖Ẳ
	invoke	Memory_Close,	ds

	popa
	RET				;
cHCD_include	endp
;---------------------------------------------------------------|
;		wb_[RpC				|
;---------------------------------------------------------------|
;								|
;								|
;	Ԃl							|
;								|
;	gpWX^						|
;		cx	R}hJE^			|
;		di	c_Head_Com_Adrs|C^			|
;		si	c_Hear_Com_Data|C^			|
;---------------------------------------------------------------|
c_Head_first	proc	near	uses	ds

	pusha

	;|C^[擪ɂB
	xor	ax,ax			;
	mov	cs:[pMML_File],ax	;
	mov	cs:[pWTD_File],ax	;|C^[擪ɂB

	;wb_[l̐ݒ
	mov	word ptr ds:[0].WTD_Mus_Name + 0	,5457h	;
	mov	word ptr ds:[0].WTD_Mus_Name + 2	,0044h	;'WTD',00h
	mov	word ptr ds:[0].WTD_Mus_Version		,0100h	;Version
	mov	word ptr ds:[0].WTD_Mus_Extr		,ax	;0
	mov	byte ptr ds:[0].WTD_Mus_Emb		,al	;0
	mov	byte ptr ds:[0].WTD_Mus_Voice		,al	;0
	mov	byte ptr ds:[0].WTD_Mus_Part		,al	;0
	mov	byte ptr ds:[0].WTD_Mus_TimeBase	,48	;
	mov	word ptr ds:[0].WTD_Mus_ExtrAdr		,ax	;0
	mov	word ptr ds:[0].WTD_Mus_DataAdr		,ax	;0

	push	cs			;
	pop	ds			;ds  cs

	.repeat

	   ;R}h
	   ;R}hʂ̓ǂݍ
	   xor	di,di				;diϊ`AhX̃|C^
	   ;cxR}h̐
	   mov	cx,cs:[offset c_Head_Com_Adrs + di]
	   .repeat
		;|C^ǂݍ
		push	cs:[pMML_File]		;|C^ۑ
		add	di,2			;|C^CNg(Word)
		mov	si,cs:[offset c_Head_Com_Adrs + di]	;siϊ`AhX
		;߈v`FbN
		.repeat
		   call	cread			;MMLt@CPǂݍ
		   lodsb
		.until	(al != ah)		;vȂ΁A`FbNB
		.if	(al == 24h)		;IH
		   pop	ax			;|C^̕A(l͖߂B)
		   dec	cs:[pMML_File]		;|C^EfBNg
						;|C^̓R}h̎ɂB
		   ;R}hB
		   .repeat
			;ZOg̐ݒ
			lodsb
			.if	(al==00h)		
				.break			;I
			.elseif	(al==010h)
				mov	ax,cs		;
			.elseif	(al==011h)
				mov	ax,cs:[segWTD_File]
			.elseif	(al==012h)
				mov	ax,cs:[segMML_File]
			.elseif	(al==0f0h)
				lodsw			;
				call	ax		;
				.continue
			.endif

			push	ds			;DSۑ
			;ItZbg̐ݒ
			push	ax			;
			lodsw				;
			mov	bx,ax			;bx  Offset Address
			lodsb				;al  R[h
			pop	ds			;DS  ۑ
			;f[^̏
			.if	(al==000h)
				call	A2H8R		;
				mov	ds:[bx],ah	;
			.elseif	(al==001h)
				call	A2H16R		;
				mov	ds:[bx],ax	;
			.elseif	(al==020h)
				;
				;	ꊇ](Ή)
				;
			.endif
			pop	ds			;DSA
		   .until	0
		   dec	cs:[pMML_File]		;
		   .break			;߃fR[hI
		.else
		   ;`FbNňvȂꍇB
		   pop	cs:[pMML_File]		;|C^A
		.endif
		dec	cx
	   .until	(zero?)			;̃R}hŔr
	   inc	CS:[pMML_File]			;|C^ECNg
	   mov	ax,CS:[szMML_File]		;MMLt@C̏I`FbN
	.until	(ax < CS:[pMML_File])		;MMLt@C[EOF]ȂΏI

	popa
	ret				;
c_Head_first	endp
;---------------------------------------------------------------|
;		wb_[RpC				|
;---------------------------------------------------------------|
;								|
;								|
;	Ԃl							|
;								|
;	gpWX^						|
;		cx	R}hJE^			|
;		di	c_Head_Com_Adrs|C^			|
;		si	c_Hear_Com_Data|C^			|
;---------------------------------------------------------------|
;
.const
c_Head_Version	db	'This Music Data is version $'
c_Head_CR	db	0dh,0ah,24h
c_Head_Size	db	'Filesize = '     ,24h
c_Head_Byte	db	' [Byte]   ( $'
c_Head_Block	db	' [Block] )',0dh,0ah,24h
;---------------------------------------------------------------
.code
c_Head_end	proc	near	uses ds es
	pusha				;WX^ۑ

	push	ds			;
	pop	es			;esds
	push	cs			;
	pop	ds			;dscs
;---------------------------------------------------------------
;o[W̕\

	xor	bx,bx			;ds:bxWTD File Segment Address

	mov	dx,offset c_Head_Version
	mov	ah,09h			;
	int	21h			;"This Music Data is Version "

	mov	ax,word ptr es:[bx].WTD_Mus_Version

	push	ax			;
	xchg	ah,al			;
	call	HEX2ASC8		;
	mov	ah,09h			;
	int	21h			;l̕\
	mov	dl,'.'
	mov	ah,02h
	int	21h			;u_v̕\
	pop	ax			;
	call	HEX2ASC8		;
	mov	ah,09h			;
	int	21h			;l̕\
	mov	dx,offset c_Head_CR	;
	mov	ah,09h			;
	int	21h			;s̕\

;---------------------------------------------------------------
;FX`wb_[̍쐬
;filename,title͍쐬ς݁B

;t@CTCYEubN
	mov	dx,offset c_Head_Size	;
	mov	ah,09h			;
	int	21h			;"Filesize = "̕\

	xor	dx,dx			;
	mov	ax,cs:[pWTD_File]	;
	dec	ax			;dx:axt@CTCYB
	mov	word ptr cs:[FX_filesize + 0],ax
	mov	word ptr cs:[FX_filesize + 2],dx

	push	ax			;
	push	dx			;
	call	HEX2ASC16		;
	mov	ah,09h			;
	int	21h			;l̕\
	mov	dx,offset c_Head_Byte	;
	mov	ah,09h			;
	int	21h			;" [Byte]"̕\
	pop	dx			;
	pop	ax			;

	mov	cx,128			;
	div	cx			;128ŊB
	cmp	dx,0			;
	jz	c_Head_end_Step0	;]肪A
	inc	ax			;ɂP𑫂B
c_Head_end_Step0:			;
	mov	word ptr cs:[FX_block],ax

	call	HEX2ASC16		;l̕\
	mov	ah,09h			;
	int	21h			;
	mov	dx,offset c_Head_Block	;
	mov	ah,09h			;
	int	21h			;" [Byte]"̕\

;---------------------------------------------------------------
;NEԂ̍쐬
;	bit 25-31	N-2000	(7)
;	bit 21-24		(4)
;	bit 16-20		(5)
;	bit 11-15		(5)
;	bit  5-10		(6)
;	bit  0- 4	b/2	(5)

	mov	ah,02ah			;
	int	21h			;t̎擾
	xor	ax,ax			;

	sub	cx,2000			;N-2000
	and	cx,007Fh		;
	or	ax,cx			;

	shl	ax,4			;
	mov	bx,dx			;
	xchg	bh,bl			;
	and	bx,000fh		;
	or	ax,bx			;

	shl	ax,5			;
	and	dx,001fh		;
	or	ax,dx			;

	push	ax			;t̕ۑ

	mov	ah,02ch			;
	int	21h			;Ԃ̎擾
	xor	ax,ax			;

	mov	bx,cx			;
	xchg	bh,bl			;
	and	bx,001fh		;
	or	ax,bx			;

	shl	ax,6			;
	and	cx,003fh		;
	or	ax,cx			;

	shl	ax,5			;b/2
	xchg	dh,dl			;
	shr	dx,1			;
	and	dx,001fh		;
	or	ax,dx			;

	pop	dx			;t̕A

	mov	word ptr cs:[FX_data + 0],ax
	mov	word ptr cs:[FX_data + 2],dx

;---------------------------------------------------------------
;I
	popa				;
	ret				;Return
c_Head_end	endp
