;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Serial Control				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
ifndef	hyoka
;===============================================================|
;			I/O Address				|
;===============================================================|
COMM_DATA		equ	0b1h	;Send / Receive data
COMM_STATUS		equ	0b3h	;Serial Status
;===============================================================|
;			INT Status bit flag			|
;===============================================================|
INT_CommSendSet		equ	001h	;CommSendlZbg@(or)
INT_CommSendReset	equ	0feh	;CommSendlZbg(and)
;===============================================================|
;			COMM Status bit flag			|
;===============================================================|
COMM_Receive		equ	001h	;Mf[^LiMj
COMM_OverRun		equ	002h	;I[o[EG[
COMM_SendEmpty		equ	004h	;Mobt@iMj
COMM_OrReset		equ	020h	;I[o[EG[̃Zbg
COMM_Baudrate9K		equ	000h	;{[[gi 9600 [bps])(+)
COMM_Baudrate38k	equ	040h	;{[[gi38400 [bps])(+)
COMM_Enable		equ	080h	;ʐMCl[u(or)
COMM_Disable		equ	07fh	;ʐMfBZ[u(and)
;===============================================================|
;			萔					|
;===============================================================|
COMM_TimeOut		equ	0ffffh	;^CAEg̎
;===============================================================|
;			ʐMJ				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		38400bpsɐݒAʐMJB		|
;===============================================================|
	even				;AhXzu
C_Open	proc near	uses ax		;
	
	mov	al,COMM_OrReset + COMM_Baudrate38k + COMM_Enable
	out	COMM_Status,al		;

	ret				;
C_Open	endp				;
;===============================================================|
;			ʐM			|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;		ʐMB				|
;===============================================================|
	even				;AhXzu
C_Close	proc near	uses ax		;

	.repeat
	  in	al,COMM_Status			;Xe[^Xǂݍ
	  .break  .if	!(al&COMM_Enable)	;ʐM@\̓Cl[uH
	.until		 (al&COMM_SendEmpty)	;Mf[^H
	and	al,COMM_Disable		;ʐMfBZ[uݒB
	out	COMM_Status,al		;o

	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	ret				;
C_Close	endp				;
;===============================================================|
;			1 byteM				|
;===============================================================|
;								|
;		al	send data				|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;		MAFIFO֏			|
;===============================================================|
	even				;AhXzu
C_Send	proc near	uses ax bx cx di si es

	pushf				;
	cli

	mov	cx,ax

	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	;n[hEFAMobt@  \tgEFAFIFOobt@ Ƃł邩`FbNB
	mov	bx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	lea	si,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	in	al,COMM_Status		;Xe[^Xǂݍ
	.if	((!(al & COMM_SendEmpty))||(bx != word ptr ds:[si]))
		;ł͂ȂBi܂Mj
		mov	di,bx			;di  ݂̏݃|C^
		inc	bx			
		.if	(bx >= word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Size)
			xor	bx,bx		;
		.endif				;bx  ̏݃|C^
		.while	(bx == word ptr ds:[si])
			call	IC_Send		;FIFȎM݂B
		.endw				;FIFOɋ󂫂o܂ŌJԂB
		mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt,bx

		les	bx,dword ptr ds:[bp].(WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset)
		mov	ax,cx			;alMf[^
		mov	byte ptr es:[di+bx],al	;FIFOobt@ɏ

		in	al,Int_Enable		;obt@Ƀf[^̂ŁA
		or	al,INT_CommSendSet	;VAMGveB[
		out	Int_Enable,al		;荞݋

	.else
		;ǂ󂾂AFIFO荞ݎgȂŒڏo͂B
		mov	ax,cx			;alMf[^
		out	COMM_DATA,al		;M
	.endif

	popf				;
	ret				;
;----------------------------------------------------------------
;C_Send_0:
;	mov	di,ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
;;	mov	di,ax			;axFIFO|C^Cnt
;
;	mov	bx,ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
;
;	inc	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
;	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
;	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Size
;	jnz	C_Send_1		;
;	mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt,0
;C_Send_1:				;
;	mov	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
;	cmp	ax,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
;	jnz	C_Send_3		;FIFOobt@͂ςH
;	mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt,bx
;	call	IC_Send			;FIFȎM݂āA
;	jmp	C_Send_1		;蒼B
;
;C_Send_3:				;
;;	mov	bx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset
;;	mov	es,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Segment
;	les	bx,dword ptr ds:[bp].(WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset)
;	pop	ax			;FIFOobt@ɏ
;	push	ax			;
;	mov	byte ptr es:[di+bx],al	;
;
;C_Send_e:
;	in	al,Int_Enable		;obt@Ƀf[^̂ŁA
;	or	al,INT_CommSendSet	;VAMGveB[
;	out	Int_Enable,al		;荞݋
;
;	pop	ax			;
;	pop	bx			;
;	pop	di			;WX^A
;	pop	es			;
;	popf				;
;	ret				;
C_Send	endp				;
;===============================================================|
;			2 byteM				|
;===============================================================|
;								|
;		ax	send data(al:LSB,ah:MSB)		|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
C_Send_Word	proc near		;
	call	C_Send			;
	xchg	al,ah			;
	call	C_Send			;
	xchg	al,ah			;
	ret				;
C_Send_Word	endp			;
;===============================================================|
;			ubNM				|
;===============================================================|
;								|
;		CX	Size					|
;		DS:SI	Data Address				|
;	Ԃl							|
;								|
;								|
;		Ƀf[^o͂B			|
;===============================================================|
	even				;AhXzu
C_Send_Block	proc near	uses ax cx si

	.repeat
		lodsb			;
		call	C_Send		;M
	.untilcxz

	ret				;
C_Send_Block	endp			;
;===============================================================|
;			1 byteM				|
;===============================================================|
;								|
;		FIFO	send data				|
;	Ԃl							|
;								|
;								|
;		FIFOɃf[^o͂B		|
;===============================================================|
	even				;AhXzu
IC_Send	proc	near	uses ax bx dx di es
	pushf				;
	cli				;

;---------------------------------------------------------------
	in	al,Int_Enable		;
	and	al,INT_CommSendReset	;VAMGveB[
	out	Int_Enable,al		;荞݋֎~

	mov	dx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Cnt
	mov	bx,word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr
	.if	(dx != bx)			;󂾂珈ȂB

	   ;܂n[hEFAőMAFIFOM͂ȂB
	   in	al,COMM_Status			;Xe[^Xǂݍ
	   .if	(al & COMM_SendEmpty)		;Mobt@H
		mov	di,bx			;di  ݂̓ǂݍ݃|C^
		inc	bx			;
		.if	(bx >= word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Size)
			xor	bx,bx		;
		.endif				;bx  ̓ǂݍ݃|C^
		mov	word ptr ds:[bp].WTD_WorkAdd_System+WTD_Sys_ComFIFO_Adr,bx
		push	bx			;
		les	bx,dword ptr ds:[bp].(WTD_WorkAdd_System+WTD_Sys_ComFIFO_Offset)
		mov	al,byte ptr es:[di+bx]	;
		out	COMM_DATA,al		;M
		pop	bx			;
	   .endif				;
	   .if	(dx != bx)			;󂾂珈ȂBiM̍checkj
		in	al,Int_Enable		;
		or	al,INT_CommSendSet	;VAMGveB[
		out	Int_Enable,al		;荞݋
	   .endif
	.endif

	popf				;
	ret				;
IC_Send	endp
;===============================================================|
endif
