;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Interrupt main program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;****************************************************************
;*								*
;*			萔					*
;*								*
;****************************************************************
;
;	͖
;
;****************************************************************
;*								*
;*			f[^e[u				*
;*								*
;****************************************************************
;===============================================================|
;			Volume					|
;===============================================================|
;								|
;	Table = 256 * log(volume +1) / log(257)			|
;								|
;===============================================================|
	even
I_Volume_Table:
;		00h,01h,02h,03h,04h,05h,06h,07h,08h,09h,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
	db	  0, 31, 50, 63, 74, 82, 89, 95,101,106,110,114,118,121,124,127
	db	130,133,135,138,140,142,144,146,148,150,152,153,155,156,158,159
	db	161,162,164,165,166,167,169,170,171,172,173,174,175,176,177,178
	db	179,180,181,182,183,184,184,185,186,187,188,188,189,190,191,191
	db	192,193,193,194,195,195,196,197,197,198,199,199,200,200,201,202
	db	202,203,203,204,204,205,206,206,207,207,208,208,209,209,210,210
	db	211,211,211,212,212,213,213,214,214,215,215,216,216,216,217,217
	db	218,218,218,219,219,220,220,220,221,221,222,222,222,223,223,223
	db	224,224,224,225,225,225,226,226,226,227,227,227,228,228,228,229
	db	229,229,230,230,230,231,231,231,232,232,232,232,233,233,233,234
	db	234,234,234,235,235,235,236,236,236,236,237,237,237,238,238,238
	db	238,239,239,239,239,240,240,240,240,241,241,241,241,242,242,242
	db	242,243,243,243,243,243,244,244,244,244,245,245,245,245,246,246
	db	246,246,246,247,247,247,247,247,248,248,248,248,249,249,249,249
	db	249,250,250,250,250,250,251,251,251,251,251,252,252,252,252,252
	db	253,253,253,253,253,253,254,254,254,254,254,255,255,255,255,255
;===============================================================|
;			Frection(Key)				|
;===============================================================|
;								|
;	Table = (3.072[MHz] / (32 * frection)) * 2^7		|
;								|
;		Frection : a = 440[Hz]				|
;								|
;								|
;	DeviceOut = 2048 - (Table / 2^(3 + Octave))		|
;								|
;===============================================================|
	even				;AhXzu
I_Frection_Table:
	dw	46978			;c	Bend Range  4
	dw	44332			;c#		( 3` 6)
	dw	41843			;d	
	dw	39495			;d#	
	dw	37278			;e	
	dw	35186			;f	
	dw	33211			;f#	
	dw	31347			;g	
	dw	29687			;g#	
	dw	27922			;a	
	dw	26360			;a#	
	dw	24880			;b	
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉEobl	*
;*								*
;****************************************************************
;*								*
;*	@t						*
;*								*
;*	EԒli̒l͕ۂKvBj		*
;*		ds:bx	L\̃AhX			*
;*		ds:bp	[Nx[XAhX			*
;*								*
;*	WX^U					*
;*		ax	ėp(ɌvZ)				*
;*		ds:bx	L\̃AhX			*
;*		cx	ėp(ɃJE^)			*
;*		dx	ėp(ɌvZ)				*
;*		ds:di	ʍ\				*
;*		es:si	tAhX				*
;*		ds:bp	[Nx[XAhX			*
;*								*
;****************************************************************
;===============================================================|
;		Interrupt Main					|
;===============================================================|
;								|
;								|
;		@t[`̌ĂяoA			|
;		^C}[̐s[`B			|
;								|
;	gpWX^						|
;		ds:bp	[N̈擪AhX			|
;		ds:bx	p[gʍ\			|
;								|
;===============================================================|
	Public	I_Start
	even					;AhXzu
I_Start:
	push	bp				;
	push	ax				;
	push	bx				;
	push	cx				;
	push	si				;
	push	di				;
	push	ds				;WX^ۑ

;---------------------------------------------------------------
;EOI̔s
	cli					;荞ݕs
	mov	al,Int_HblankSet		;
	out	Int_Eoi,al			;o

;	in	al,Int_Enable			;
;	and	al,INT_HblankReset		;VAMGveB[
;	out	Int_Enable,al			;荞݋֎~

;---------------------------------------------------------------
;oN̐ݒ

ifndef	IRAM		;DGROUP=IRAM̏ꍇAsv
	;'/ram0'ANZX́AȂB
	in	al,BankSram			;݂SRAM Bank𓾂
	.if	(al==BANK_USERDS0)||(al==BANK_USERDS1)
endif

;---------------------------------------------------------------
;[NGAAhX̎擾

	WTD_WorkGet	ds,bp			;[NGAAhX̎擾
	lea	bx,[bp + WTD_WorkAdd_System]	;ds;bxʍ\

;===============================================================|
;	PCM Voice ̏i with CPU Powerj			|
;===============================================================|
;	WX^gp						|
;		di	PCM Voicep\ ̃|C^	|
;		si	*.wav ̃|C^			|
;		cx	gps				|
;		dx	gps				|
;		es	gps				|
;===============================================================|

	;-----------------------------------------------
	;^C}[G~[g邩H
	.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_TimerEmulate)

	    ;------------------------------------------------
	    ;^C}[G~[g鎞ɒǉ鏈B	;
	    ;CALL߂ƁAret߂6clockܑ̂Ȃ		;
	    ;------------------------------------------------
	    ;PCM Voice CPUp[Ŗ炷H
	    .if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Pcm)
	;
	;	to do	Sound-DMA gȂ[h`FbN
	;

		;WX^ݒ
	;	mov	di,bp					;
	;	add	di,WTD_WorkAdd_PCM			;dip[gʍ\
		lea	di,[bp + WTD_WorkAdd_PCM]

		;AhX擾
		push	ds					;WX^ۑ
		lds	si,dword ptr ds:[di].WTD_PcmAddress	;es:siPlay Address
		;f[^擾
	;	mov	al,ds:[si]				;(ӁFPipeLine)
	;	inc	si					;tOω
		lodsb
		pop	ds					;WX^A
		;f[^o
		out	PCM_Com_VolumeCh2,al			;o

		;AhXۑ
		mov	word ptr ds:[di].WTD_PcmAddress+0,si	;AhXۑ
		;|C^`FbNiZOgEHj
		.if	(si==0)
			add	word ptr ds:[di].WTD_PcmAddress+2,1000h
		.endif

		;IH
		sub	word ptr ds:[di].WTD_PcmSize+0,1	;PcmSize fBNg
		sbb	word ptr ds:[di].WTD_PcmSize+2,0	;
		mov	ax,word ptr ds:[di].WTD_PcmSize+0	;
		or	ax,word ptr ds:[di].WTD_PcmSize+2	;
		.if	(zero?)					;
			;PCM Voice I
			and	ds:[bx].WTD_Sys_Flag,WTD_Sys_PcmR
			and	ds:[bx].WTD_Sys_Flag,WTD_Sys_EffectMask2R
			mov	ch,81h				;ݒ蕜Ach2
			call	I_Effect_Return			;
		.endif
	    .endif

	    ;---------------				;
	    ;e|pJE^[@fBNg		;
	    dec	ds:[bx].WTD_Sys_TempoCounter		;
	    jnz	I_MusicEffectStep			;t΂B

	.endif

	;-----------------------------------------------
	;PCM Voice  Sound DMA Ŗ炵ĂB
	.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Pcm)
	;
	;	to do	Sound-DMA g[h`FbN
	;
	;   in	al, TEhDMA
	   .if	!(al & 80h)				;
		and	ds:[bx].WTD_Sys_Flag,WTD_Sys_PcmR
		and	ds:[bx].WTD_Sys_Flag,WTD_Sys_EffectMask2R
		mov	ch,81h				;ݒ蕜Ach2
		call	I_Effect_Return			;
	   .endif
	.endif

;===============================================================|
;	t  ʉ					|
;===============================================================|
;	WX^gp						|
;		ds:di	ʍ\		jok		|
;	i	es:si	tAhX		jok	j	|
;		ax	ėp(ɌvZ)		jok		|
;		cx	ėp(ɃJE^)	jok		|
;		dx	ėp(ɌvZ)		jok		|
;===============================================================|
;t[`
	push	dx				;
	push	es

	;t邩H
	.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Music)

		;WX^ݒ
		lea	di,[bp + WTD_WorkAdd_Ch0]
		mov	es,ds:[bx].WTD_Sys_MusicSegment	;estf[^ZOg

		;t[`̌Ăяo
		xor	cx,cx				;ił͍ő'20'B
		mov	cl,ds:[bx].WTD_Sys_MusicPart	;ł͍ő' 4'B
		.while	(cx!=0)
			call	I_Play			;
			add	di,WTD_WorkChSize	;\̂̃TCY80h(0x80)
			dec	cx			;
		.endw

	.endif

;---------------------------------------------------------------
;ʉ[`

	;ʉ邩H
	.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Effect)

		;WX^ݒ
		lea	di,[bp + WTD_WorkAdd_Ech0]
		mov	es,ds:[bx].WTD_Sys_EffectSegment	;esʉf[^ZOg

		;t[`̌Ăяo
		xor	cx,cx				;
		mov	cl,ds:[bx].WTD_Sys_EffectPart	;ő'3'B
		.while	(cx!=0)
			call	I_Play			;
			add	di,WTD_WorkChSize	;\̂̃TCY80h(0x80)
			dec	cx			;
		.endw

	.endif

;---------------------------------------------------------------
;PCM VioceʉĂAIłȂ΁A
;^C}[߂B

	;^C}[G~[gł邩H
	.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_TimerEmulate)

	    ;PcmVioceIH
	    .if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Pcm)

		;PcmViocep̏ꍇ
		;^C}[ݒ
		mov	ax,1				;荞ݎ͍ő
		call	T_Set_Frection			;(12KHz)
		;^C}[JE^ݒ
		mov	ax,ds:[bx].WTD_Sys_Tempo	;
		mov	ds:[bx].WTD_Sys_TempoCounter,ax	;TempoCounter

	    .else

		;PcmVioceȈꍇB
		;^C}[ݒ
		mov	ax,ds:[bx].WTD_Sys_Tempo	;^C}[̐ݒ
		call	T_Set_Frection			;
		;^C}[JE^ݒ
	;	xor	ax,ax				;ax0
		mov	ds:[bx].WTD_Sys_TempoCounter,0	;TempoCounter = 0
		;tO
	;	and	ds:[bx].WTD_Sys_Flag,WTD_Sys_PcmR		;PCMʉfBZ[u
	;	and	ds:[bx].WTD_Sys_Flag,WTD_Sys_PcmEndR		;̃tO͔p~
	;	and	ds:[bx].WTD_Sys_Flag,WTD_Sys_EffectMask2R	;ch2 ʉ}XNRes
		and	ds:[bx].WTD_Sys_Flag,WTD_Sys_TimerEmulateR	;^C}[G~[gRes
	;	mov	ch,81h				;ݒ蕜Ach2
	;	call	I_Effect_Return			;

	    .endif
	.endif

	pop	es
	pop	dx				;

;===============================================================|
I_MusicEffectStep:					;

;
;---------------------------------------------------------------
;oN̕A
ifndef	IRAM		;DGROUP=IRAM̏ꍇAsv
;
	.endif

endif
;---------------------------------------------------------------
;荞݂̏I

;	cli				;荞݋֎~
;	in	al,Int_Enable		;
;	or	al,INT_HblankSet	;^C}[
;	out	Int_Enable,al		;荞݋

	pop	ds				;WX^A
	pop	di				;
	pop	si				;
	pop	cx				;
	pop	bx				;
	pop	ax				;
	pop	bp				;
	iret					;
;===============================================================|
;		Music Control Main				|
;===============================================================|
;								|
;		ds:bp	[Nx[XAhX			|
;		ds:bx	L\̃AhX			|
;		ds:di	ʍ\				|
;	WX^gp						|
;		es:si	tAhX				|
;		cx	p[gځH		jNG		|
;		ax	Q[g^CvZp	jok		|
;		dx	ėp(ɌvZ)		jok		|
;===============================================================|
	even				;AhXzu
I_Play	proc	near	uses	cx	;

	;t`FbN
	.if	!(ds:[di].WTD_FlagControl&WTD_Ctrl_PlayEnd)

		;JE^[EfBNg
		dec	ds:[di].WTD_LengCounter
		mov	ax,ds:[di].WTD_Leng			;
		sub	ax,ds:[di].WTD_LengCounter		;axoߎ


		;ɂAL[IfBC
		.if	(ax==ds:[di].WTD_KeyOnDelay)		;'k'R}h̔
			call	I_Play_KeyOn			;
		.endif


		;ɂAFQ
		.if	( !(ds:[di].WTD_ProgramDecay&80h) && (ds:[di].WTD_Key!=0ffh) && (ax==ds:[di].WTD_ProgramDecayRate) )
			push	ax				;
			mov	al,ds:[di].WTD_ProgramDecay	;
			and	al,07fh				;bit̃}XN
			mov	dx,offset CGROUP:I_Table_Voice	;
			call	I_Table_Jump			;
			pop	ax				;
		.endif


		;ɂAF
		.if	( !(ds:[di].WTD_Program2nd&80h) && (ds:[di].WTD_Key!=0ffh) && (ax==ds:[di].WTD_ProgramRate) )
			push	ax				;
			mov	al,ds:[di].WTD_Program2nd	;
			and	al,07fh				;bit̃}XN
			mov	dx,offset CGROUP:I_Table_Voice	;
			call	I_Table_Jump			;
			pop	ax				;
		.endif


		;ɂAQ[g^C
		.if	(ax!=ds:[di].WTD_GateTimeStepFirst)	;'u'R}hkeyoff邩H

			mov	ax,ds:[di].WTD_Leng		;'Q','U','q'R}h̔
			mov	ch,ds:[di].WTD_GateTime8	;chGateTime8
			rol	ch,1				;
			shr	ch,1				;Bit 7 Reset & Bit 7 -> Cy Flag
			.if	(!Carry?)
				mov	dx,8			;'Q'R}h
				sub	dl,ch			;dx = 8 | ch
				mul	dx			;dx:ax = ax ~ dx
				shr	dx,1			;
				shr	ax,1			;
				shr	dx,1			;
				shr	ax,1			;
				shr	dx,1			;
				shr	ax,1			;ax = dx:ax  cl
			.else
				mov	cl,100			;cl = 100
				mov	dx,100			;dx = 100
				sub	dl,ch			;dx = dx | ch
				mul	dx			;dx:ax = ax ~ dx
				xor	ch,ch			;
				div	cx			;ax = dx:ax  cl
			.endif


			add	ax,ds:[di].WTD_GateTimeStepLast	;ax = ax + WTD_GateTimeStepLast
			.if	(Carry?)			;I[o[t[A
				mov	ax,0ffffh		;őlɏCB
			.endif					;
			.if	(ax==ds:[di].WTD_LengCounter)	;
				call	I_Play_KeyOff		;
			.endif

		.else
			and	ds:[di].WTD_FlagTai, 0FEh	;Tai֌WȂKeyOff
			call	I_Play_KeyOff			;
		.endif


		;JE^OȂ΁AR}h
		.if	(ds:[di].WTD_LengCounter==0)		;JE^OH

			mov	si,ds:[di].WTD_Address		;es:siPlay Address
			call	I_Play_Loop			;䃋[`ցB
			mov	ds:[di].WTD_Address,si		;

	;		;tIH@@KeyOnDelay͂OH
			.if	(!(ds:[di].WTD_FlagControl&WTD_Ctrl_PlayEnd) && (ds:[di].WTD_KeyOnDelay==0))
				call	I_Play_KeyOn		;ł΁AKeyOn
			.endif
		.endif


	.endif

	mov	ax, ds:[di].WTD_FlagControl
	.if	!( (ds:[bx] & WTD_Sys_Music) && (ax & WTD_Ctrl_PlayEnd) && (ax & WTD_Ctrl_Effect) )
		;䃋[`
		call	I_Play_Pan			;p
		call	I_Play_Volume			;ʐ
		.if	(ds:[di].WTD_ExprSet!=0)	;@ʂOłȂ
			call	I_Play_Frection		;
		.endif
	.endif

	ret				;
I_Play	endp
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				[v				*
;*								*
;****************************************************************
;===============================================================|
;								|
;		ds:bp	[Nx[XAhX			|
;		ds:bx	L\̃AhX			|
;		ds:di	ʍ\				|
;		es:si	tAhX				|
;	WX^gp						|
;		cx	p[gځH		jok		|
;		ax	Q[g^CvZp	jok		|
;		dx	ėp(ɌvZ)		jok		|
;===============================================================|
	even				;AhXzu
I_Play_Loop	proc	near		;

	.while	( !(ds:[di].WTD_FlagControl&WTD_Ctrl_PlayEnd) && (ds:[di].WTD_LengCounter==0) )

		;tf[^ǂݍ
		lodsb	es:[si]

		;R}h^Cv`FbN
		rol	al,1			;
		shr	al,1			;cyCommand Type

		;ꂼ֏R[
		.if	(Carry?)
			call	I_PlayKey		;
		.else
			call	I_PlayCommand		;
		.endif

	.endw

	ret				;
I_Play_Loop	endp
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				KeyOn,KeyOff		*
;*								*
;****************************************************************
;*								*
;*		ds:bp	[Nx[XAhX			*
;*		ds:bx	L\̃AhX			*
;*		ds:di	ʍ\				*
;*		es:si	tAhX				*
;*	WX^gp						*
;*		ax	ėp(ɌvZ)		jNG		*
;*		cx	Flag		jNG		*
;*		dx	LFO/EMB\	jok		*
;****************************************************************
;===============================================================|
;			KeyOn (Hardware,Software)		|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn	proc	near	uses	ax cx

	;xł͂Ȃ  O^Cł͂Ȃ
	.if	((ds:[di].WTD_Key!=0ffh) && !(ds:[di].WTD_FlagTai & 02h))

		;F
		mov	al,ds:[di].WTD_Program2nd	;'@'R}hKv̊mF
		and	al,ds:[di].WTD_Program3rd	;2,3p[^̎w肪A͖B
		.if	!(al&080h)
			mov	al,ds:[di].WTD_Program1st	;
			and	al,07fh				;bit̃}XN
			mov	dx,offset CGROUP:I_Table_Voice	;
			call	I_Table_Jump			;
		.endif

		;Emb͏KvB
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_ExprEmb)
			mov	cx,WTD_Ctrl_EmbVol		;
			mov	dx,WTD_ExprEmb			;
			call	I_Play_KeyOn_Emb		;
		.else
			mov	ds:[di].WTD_ExprEmbLevelSet,0ffh
		.endif

	;	.if	(ds:[di].WTD_FlagControl&0037h)	;EmbȊO̊mFB\tgEFAȂ΂B

		;Emb
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_BendEmb)
			mov	cx,WTD_Ctrl_EmbFreq		;
			mov	dx,WTD_BendEmb			;
			call	I_Play_KeyOn_Emb		;
		.endif

		;pEmb
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_PanEmb)
			mov	cx,WTD_Ctrl_EmbPan		;
			mov	dx,WTD_PanEmb			;
			call	I_Play_KeyOn_Emb		;
		.endif

		;LFO
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_ExprLFO)
			mov	dx,WTD_ExprLFO			;
			call	I_Play_KeyOn_LFO		;
		.endif

		;LFO
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_BendLfo)
			mov	dx,WTD_BendLFO			;
			call	I_Play_KeyOn_LFO		;
		.endif

		;pLFO
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_PanLFO)
			mov	dx,WTD_PanLFO			;
			call	I_Play_KeyOn_LFO		;
		.endif

;		.endif

ifndef	hyoka	;--------------------------------ł͖
		;W[V
		xor	ax,ax					;
		.if	(ds:[di].WTD_ModLevelSet!=al)		;
			mov	ds:[di].WTD_ModLevelSet,al	;
			mov	cl,MIDI_Ctrl_Mod		;
			mov	dx,offset CGROUP:I_Table_CtrlChgB
			call	I_Table_Jump			;W[VOɂB
		.endif
endif	;----------------------------------------

	.endif
	ret				;
I_Play_KeyOn	endp
;===============================================================|
;			KeyOff (Hardware,Software)		|
;===============================================================|
	even				;AhXzu
I_Play_KeyOff	proc	near	uses	ax cx

	.if	!(ds:[di].WTD_FlagTai & 01h)

		;n[hEFAKeyOff
		mov	dx,offset CGROUP:I_Table_KeyOff	;
		call	I_Table_Jump			;KeyOff

		;F
		.if	!(ds:[di].WTD_Program3rd&80h)	;'@'R}h	Kv̊mF
			mov	al,ds:[di].WTD_Program3rd	;
			and	al,07fh				;bit̃}XN
			mov	dx,offset CGROUP:I_Table_Voice	;
			call	I_Table_Jump			;
		.endif

		;Emb
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_ExprEmb)
			mov	cx,WTD_Ctrl_EmbVol		;
			mov	dx,WTD_ExprEmb			;
			call	I_Play_KeyOff_Emb		;
		.else
			.if	(ds:[di].WTD_Channel&80h)	;MIDIp[g̏ꍇ͑삵ȂB
				mov	ds:[di].WTD_ExprEmbLevelSet,000h
			.endif
		.endif

		;Emb
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_BendEmb)
			mov	cx,WTD_Ctrl_EmbFreq		;
			mov	dx,WTD_BendEmb			;
			call	I_Play_KeyOff_Emb		;
		.endif

		;pEmb
		.if	(ds:[di].WTD_FlagControl&WTD_Ctrl_PanEmb)
			mov	cx,WTD_Ctrl_EmbPan		;
			mov	dx,WTD_PanEmb			;
			call	I_Play_KeyOff_Emb		;
		.endif

	.endif
	ret				;
I_Play_KeyOff	endp
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				Eʐ			*
;****************************************************************
;*								*
;*		ds:bp	[Nx[XAhX			*
;*		ds:bx	L\̃AhX			*
;*		ds:di	ʍ\				*
;*		es:si	tAhX				*
;*	WX^gp						*
;*		ax	ėp(ɌvZ)		jok		*
;*		cx	ėp			jok		*
;*		dx	ėp			jok		*
;****************************************************************
;===============================================================|
;			 (Detune,LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Frection	proc	near		;

ifndef	hyoka	;--------------------------------ł͖
	;W[V(MIDI)
	mov	ax,ds:[di].WTD_Leng		;W[V
	sub	ax,ds:[di].WTD_LengCounter	;
	.if	(ax==ds:[di].WTD_ModDecay)
	  mov	al,ds:[di].WTD_ModLevel		;
	  mov	ds:[di].WTD_ModLevelSet,al	;
	  mov	cl,MIDI_Ctrl_Mod		;
	  mov	dx,offset CGROUP:I_Table_CtrlChgB
	  call	I_Table_Jump			;W[VB
	.endif
endif	;----------------------------------------


	;ǂݍ
	mov	ax,ds:[di].WTD_Bend	;

	;fB`[̉Z
	add	ax,ds:[di].WTD_BendDetune

	;LFO
	.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_BendLFO)
		mov	dx,WTD_BendLFO		;
		call	I_Play_LFO		;
		add	ax,dx			;
	.endif

	;Emb
	.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_BendEmb)
		mov	cx,WTD_Ctrl_EmbFreq	;
		mov	dx,WTD_BendEmb		;
		call	I_Play_Emb		;
		sub	dl,80h			
		.if	(carry?)
		  mov	dh,0ffh			;dxdl(t)
		.endif
		shl	dx,6			;~2^6
		add	ax,dx			;Z
	.endif

	;̏o
	mov	dx,offset CGROUP:I_Table_Frection
	call	I_Table_Jump		;Zbg

	ret				;
I_Play_Frection	endp
;===============================================================|
;			ʐ (Detune,LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Volume	proc	near		;

	xor	ax,ax			;

	mov	dl, ds:[di].WTD_KeySet + 0	;
ifndef	hyoka	;--------------------------------ł͖
	and	dl, ds:[di].WTD_KeySet + 1	;
	and	dl, ds:[di].WTD_KeySet + 2	;
	and	dl, ds:[di].WTD_KeySet + 3	;
	and	dl, ds:[di].WTD_KeySet + 4	;
	and	dl, ds:[di].WTD_KeySet + 5	;
	and	dl, ds:[di].WTD_KeySet + 6	;
	and	dl, ds:[di].WTD_KeySet + 7	;
endif	;----------------------------------------

	;xłȂAʁOłȂꍇɎs
	cmp	dl, 0FFh
	jnz	I_Play_Volume_Step1

	.if	(ds:[di].WTD_ExprEmbLevelSet != 0)

		;[X@\gH
		.if	(ds:[di].WTD_ReleaseVolume == 0FFh)

I_Play_Volume_Step1:
			;ʓǂݍ݁14bitɕϊ
			mov	al,ds:[di].WTD_Expr	;
			inc	ax			;
			shl	ax,7			;128{ɂB
			dec	ax			;iRange:0`16383j

			;fB`[̉Z
			add	ax,ds:[di].WTD_ExprDetune

			;LFO
			.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_ExprLFO)
				mov	dx,WTD_ExprLFO		;
				call	I_Play_LFO		;
				add	ax,dx			;
			.endif

			;Emb
			.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_ExprEmb)
				mov	cx,WTD_Ctrl_EmbVol	;
				mov	dx,WTD_ExprEmb		;
				call	I_Play_Emb		;
		;		mov	ds:[di].WTD_ExprEmbLevelSet,dl	;Gx[vl
			.endif

			;ʂA7bitɕ␳
			inc	ax			;
			shr	ax,7			;ax{(ax+1)128}-1
			dec	ax			;iRange:0`127j
			.if	(ah==0)
				.if	(al>=80h)
				  mov	ax,07fh		;if (128=>ax>255){ax = 0x7F;};
				.endif
			.else
				xor	ax,ax		;ax = 0x00;
			.endif

			;Gx[vʂ̍
			xor	cx,cx			;
			mov	cl,al			;
			inc	cx				;cx+1
			xor	ax,ax				;ax0
			mov	al,ds:[di].WTD_ExprEmbLevelSet	;ax
			inc	ax				;ax\tg+1
			mul	cx			;
			dec	ax			;
			shl	ax,1			;al((Vol.+1)~(SoftVol.+1)-1)^128
			mov	al,ah			;(Range:0`255)

		.else
			mov	al,ds:[di].WTD_ReleaseVolume
			stc
			rol	al, 1
			mov	ds:[di].WTD_ExprEmbLevelSet, al
		.endif


		;\tgEFAʂ̍
		xor	cx,cx			;
		mov	cl,al			;
		inc	cx			;cx+1
		xor	ax,ax			;ax0
		.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_Effect)
		  mov	al,ds:[bx].WTD_Sys_VolumeEffect	;axʉ
		.else
		  mov	al,ds:[bx].WTD_Sys_VolumeMusic	;axy
		.endif


	;	mov	bx,offset CGROUP:I_Volume_Table	;logZ
	;	xlat
	;	xor	ah,ah
		mov	si,ax			;
		and	si,00ffh		;
		mov	al,byte ptr cs:[CGROUP:I_Volume_Table + si]

		inc	ax			;ax\tg+1
		mul	cx			;
		dec	ax			;al((2*Vol.+1)~(SoftVol.+1)^256)-1
		mov	al,ah			;(Range:0`255)
		shr	al,1			;al2 (Range:0`127)

	.else

	.endif

	;ʂ̏o
	mov	dx,offset CGROUP:I_Table_Volume
	call	I_Table_Jump		;ʃZbg

	ret				;
I_Play_Volume	endp
;===============================================================|
;			p|bg (LFO,Emb)		|
;===============================================================|
	even				;AhXzu
I_Play_Pan	proc	near		;

	;p|bgǂݍ
	mov	al,ds:[di].WTD_Pan	;
	and	ax,0007fh		;

	;\tgEFAȂ΂B
      .if	(ds:[di].WTD_FlagControl & (WTD_Ctrl_PanLFO + WTD_Ctrl_PanEmb))

	;128{ɂB
	inc	ax			;
	shl	ax,7			;
	dec	ax			;iRange:0`16383j

	;p|bgLFO
	.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_PanLFO)
		mov	dx,WTD_PanLFO		;
		call	I_Play_LFO		;
		add	ax,dx			;
	.endif

	;p|bgEmb
	.if	(ds:[di].WTD_FlagControl & WTD_Ctrl_PanEmb)
		mov	cx,WTD_Ctrl_EmbPan	;
		mov	dx,WTD_PanEmb		;
		call	I_Play_Emb		;
		sub	dl,80h			;
		.if	(carry?)
		  mov	dh,0ffh			;dxdl(t)
		.endif
		shl	dx,6			;~2^6
		add	ax,dx			;Z
	.endif

	;p|bgA7bitɕ␳
	inc	ax			;
	shr	ax,7			;ax{(ax+1)128}-1
	dec	ax			;iRange:0`127j

	.if	(ah==0)
		.if	(al>=80h)
		  mov	ax,07fh		;if (128=>ax>255){ax = 0x7F;};
		.endif
	.else
		xor	ax,ax		;ax = 0x00;
	.endif

      .endif

	;p|bg̏o
	.if	(ds:[di].WTD_PanSet!=al)
	  mov	ds:[di].WTD_PanSet,al	;
ifndef	hyoka	;------------------------ł͖
	  mov	cl,MIDI_Ctrl_Pan	;
	  mov	dx,offset CGROUP:I_Table_CtrlChgB
	  call	I_Table_Jump		;p|bgZbg
endif	;--------------------------------
	.endif

	ret				;
I_Play_Pan	endp
;****************************************************************
;*								*
;*			荞݃[`			*
;*				tEʉ䕔		*
;*				ELFO,Emb		*
;*				Aʂœ̃[`	*
;*								*
;****************************************************************
;*								*
;*		ds:bp	[Nx[XAhX			*
;*		ds:bx	L\̃AhX			*
;*		ds:di	ʍ\				*
;*		es:si	tAhX				*
;*		dx	[NAhX擪	ԂlɂȂ	*
;*		cx	Flag		jok		*
;*	WX^gp						*
;*		ax	ėp(ɌvZ)		jNG		*
;*	Ԃl						*
;*		dx	ψ(x)				*
;****************************************************************
;===============================================================|
;			LFO	KeyOn				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn_LFO	proc	near	uses	ax di

;	mov	bp,dx					;
	add	di,dx

	;JE^[(Rate)̏
	mov	ah,ds:[di].WTD_ChLfo_DecayRate		;DR
	add	ah,ds:[di].WTD_ChLfo_SpeedRate		;SR
	mov	ds:[di].WTD_ChLfo_RateCounter,ah	;

	;JE^[(Count)̏
	mov	ah,ds:[di].WTD_ChLfo_Count		;
	shr	ah,1					;ah = ah / 2	~X
;	.if	(ah==1)
;	  xor	ah,ah					;ׁ݊̈AB
;	.endif
	mov	ds:[di].WTD_ChLfo_CountCounter,ah	;

	;x̏
	xor	ax,ax					;
	mov	ds:[di].WTD_ChLfo_LevelSet,ax		;

	ret						;
I_Play_KeyOn_LFO	endp
;===============================================================|
;			Emb	KeyOn				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOn_Emb	proc	near	uses	ax di si

	lea	si,[di]
	add	di,dx

	xor	ax,ax
	mov	al,ds:[di].WTD_ChEmb_Address	;
	and	al,0f0h				;
	mov	ds:[di].WTD_ChEmb_Address,al	;ʒu
	.if	(ds:[si].WTD_FlagControl & cx)
	  mov	ah,01h				;
	.endif

	lea	si,[bp + WTD_WorkAdd_Emb]	;Gx[vAhX
	add	si,ax				;f[^AhX
	lodsw					;
	mov	dx,ds:[si]			;

	mov	ds:[di].WTD_ChEmb_Rate,al	;
	.if	(ah&80h)
	  neg	ah				;
	.endif
	mov	ds:[di].WTD_ChEmb_Counter,ah	;
	mov	ds:[di].WTD_ChEmb_MaxMin,dl	;
	mov	ds:[di].WTD_ChEmb_LevelSet,dh	;

	ret					;
I_Play_KeyOn_Emb	endp
;===============================================================|
;			Emb	KeyOff				|
;===============================================================|
	even				;AhXzu
I_Play_KeyOff_Emb	proc	near	uses ax di si

	lea	si,[di]
	add	di,dx

	xor	ax,ax
	mov	al,ds:[di].WTD_ChEmb_Address	;
	and	al,0f0h				;
	or	al,00cH				;
	mov	ds:[di].WTD_ChEmb_Address,al	;ʒu
	.if	(ds:[si].WTD_FlagControl & cx)
	  mov	ah,01h				;
	.endif

	lea	si,[bp + WTD_WorkAdd_Emb]	;Gx[vAhX
	add	si,ax				;f[^AhX
	lodsw					;
	mov	dx,ds:[si]			;

	mov	ds:[di].WTD_ChEmb_Rate,al	;
	.if	(ah&80h)
	  neg	ah				;
	.endif
	mov	ds:[di].WTD_ChEmb_Counter,ah	;
	mov	ds:[di].WTD_ChEmb_MaxMin,dl	;

	ret					;
I_Play_KeyOff_Emb	endp
;===============================================================|
;			Emb	C				|
;===============================================================|
	even				;AhXzu
I_Play_Emb	proc	near	uses	ax di si

	lea	si,[di]
	add	di,dx

;	mov	al, ds:[di].WTD_ChEmb_Address
;	and	al, 00Fh
;	.if	!((ds:[di].WTD_ChEmb_LevelSet == 0) && (al == 00Ch))

	  ;Speed
	  dec	ds:[di].WTD_ChEmb_Counter
	  .if	(zero?)

		;AhX̐ݒ
		xor	ax,ax
		mov	al,ds:[di].WTD_ChEmb_Address
		.if	(ds:[si].WTD_FlagControl & cx)
			mov	ah,01h			;axAddress
		.endif
		lea	si,[bp + WTD_WorkAdd_Emb]	;Gx[vAhX
		add	si,ax				;sif[^AhX

		;CountĐݒ
		mov	ah,ds:[si].WTD_Emb_AS		;
		.if	(ah & 80h)
			neg	ah			;
		.endif
		mov	ds:[di].WTD_ChEmb_Counter,ah	;

		;Rate  Level
		mov	al,ds:[di].WTD_ChEmb_LevelSet
		.if	(ds:[si].WTD_Emb_AS & 80h)	;r( or )
		  sub	al,ds:[si].WTD_Emb_AR		;
		  jc	I_Play_Emb_Step3		;
		  cmp	al,ds:[si].WTD_Emb_AL		;ŏl`FbN
		  jnc	I_Play_Emb_StepEnd		;
		.else
		  add	al,ds:[si].WTD_Emb_AR		;
		  jc	I_Play_Emb_Step3		;
		  cmp	al,ds:[si].WTD_Emb_AL		;ől`FbN
		  jc	I_Play_Emb_StepEnd		;
		.endif

		;ől𒴂ꍇ
I_Play_Emb_Step3:					;
		mov	al,ds:[si].WTD_Emb_AL		;
		mov	ah,ds:[di].WTD_ChEmb_Address	;
		and	ah,0fh				;

		.if	(ah<08h)
		  push	ax				;
		  add	ds:[di].WTD_ChEmb_Address,04h	;
		  add	si,4				;AhX̐ݒ
		  lodsw					;
		  mov	dx,ds:[si]			;
		  mov	ds:[di].WTD_ChEmb_Rate,al	;
		  .if	(ah&80h)
			neg	ah			;
		  .endif
		  mov	ds:[di].WTD_ChEmb_Counter,ah	;
		  mov	ds:[di].WTD_ChEmb_MaxMin,dl	;
		  pop	ax				;
		.endif
I_Play_Emb_StepEnd:					;

		mov	ds:[di].WTD_ChEmb_LevelSet,al	

	  .endif
;	.endif

	xor	dx,dx				;
	mov	dl,ds:[di].WTD_ChEmb_LevelSet	;

	ret					;
I_Play_Emb	endp
;===============================================================|
;			LFO	C				|
;===============================================================|
	even				;AhXzu
I_Play_LFO	proc	near	uses	ax di

	add	di,dx

	;Rate
	dec	ds:[di].WTD_ChLfo_RateCounter		;
	.if	(zero?)
		mov	al,ds:[di].WTD_ChLfo_SpeedRate		;
		mov	ds:[di].WTD_ChLfo_RateCounter,al	;

		;Level(dxLevel)
		mov	dx,ds:[di].WTD_ChLfo_LevelSet		;dxLevel
		mov	al,ds:[di].WTD_ChLfo_CountCounter	;
	;	shr	al,1	;
		.if	(al>ds:[di].WTD_ChLfo_Count)		;Z̕
		  sub	dx,ds:[di].WTD_ChLfo_Level		;Z
		.else
		  add	dx,ds:[di].WTD_ChLfo_Level		;Z
		.endif
		mov	ds:[di].WTD_ChLfo_LevelSet,dx		;ۑ

		;Count
		dec	ds:[di].WTD_ChLfo_CountCounter		;
		.if	(zero?)
		  mov	al,ds:[di].WTD_ChLfo_Count		;JE^[
		  shl	al,1					;al = al ~ 2	íHj
		  mov	ds:[di].WTD_ChLfo_CountCounter,al	;
		.endif
	.endif

	mov	dx,DS:[di].WTD_ChLfo_LevelSet		;dxLFÕx

	ret					;
I_Play_LFO	endp
;****************************************************************
;*								*
;*			ʉI̐ݒ蕜A			*
;*								*
;****************************************************************
;*								*
;*		ch	`l				*
;*		ds:bx	System Sturuc				*
;*		ds:di	Part Sturuc				*
;****************************************************************
	even				;AhXzu
I_Effect_Return	proc	near			;
	pusha					;WX^ۑ

;---------------------------------------------------------------
;tÕZbg
	mov	cl,ch				;
	and	cl,07h				;
	inc	cl				;
	mov	ax,0f7ffh			;
	rol	ax,cl				;
	and	ds:[bx].WTD_Sys_Flag,ax		;
;---------------------------------------------------------------
;Channel Mode̕A
	mov	ax,ds:[bx].WTD_Sys_Flag		;ahChannel Mode Flag
	and	ah,0fh				;ah̑FlagMask
	shl	ah,4				;
	xchg	ah,al				;
	mov	ah,08h				;ah08h
	mov	cl,ch				;
	and	cl,07h				;5bit}XN
	inc	cl				;
	shl	ah,cl				;ah = ah*2^cl (SetBit)
	call	SP_Set_Channel			;

;---------------------------------------------------------------
;p[g

	;p[g
	mov	cl,MusicMaxPart			;20񃋁[v
	lea	di,[bp + WTD_WorkAdd_Ch0]	;
	.repeat
	  .if	(ds:[di].WTD_Channel == ch)

	    push	es
	    mov	es, ds:[bx].WTD_Sys_MusicSegment
	    .if	!(ds:[di].WTD_FlagControl & WTD_Ctrl_PlayEnd)


		;A
		and	ch,03h				;`l񂾂ɂB

		;g
		mov	ax,ds:[di].WTD_FrectionSet	;g̕A
		call	SP_Set_Frection			;

		;
		mov	al,ds:[di].WTD_ExprPanSet	;ʂ̕A
		call	SP_Set_Volume			;

		;F
		mov	al, ds:[di].WTD_Voice
		inc	ds:[di].WTD_Voice
		call	I_SP_Voice

		.if	(ch == 2)
			;XEB[vl(ch=02h)
			mov	al,ds:[di].WTD_SweepLevel	;
			mov	ah,ds:[di].WTD_SweepTime	;
			call	SP_Set_Sweep			;
		.elseif	(ch == 3)
			;mCY[h(ch=03h)
			mov	ah,01fh				;
			mov	al,ds:[di].WTD_NoiseMode	;
			or	al,018h				;
			and	al,ah				;
			call	SP_Set_Noise			;
		.endif

	    .else
		.if	(ds:[bx].WTD_Sys_Flag & WTD_Sys_Music)
			mov	ax,0			;GNXvbV = 0
			call	SP_Set_Volume			;
			mov	ax,0			;F = 0
			call	SP_Set_Voice
		.endif
	    .endif
	    pop		es
	    .break
	  .endif
	  add	di,WTD_WorkChSize		;\̂̃TCY80h(0x80)
	  dec	cl
	.until	(zero?)

;---------------------------------------------------------------
I_Effect_Return_End:
	popa					;WX^A
	ret					;
I_Effect_Return	endp
