;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Un MML Compiler Program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|

assume	cs:code,ds:code,es:code,ss:code

code	segment

.186

	org	0100h

WTD_UnMML_Compiler_:
;=======================================================================|
;				Start Up				|
;=======================================================================|
	jmp	_main			;C[`
;=======================================================================|
;				define					|
;=======================================================================|
WtdIL_Name		equ	'WTD',0
MusicMaxPart		equ	20	;ił20p[g
EffectMaxPart		equ	3	;ʉ3 p[g
;
;		RpC
;
D_ZEN	DB	128		;P	l
;=======================================================================|
;				Start					|
;=======================================================================|
include bank.inc	;oN
include wtd_ver.inc	;WTD Version infomation
include wtd_def.inc	;WTD Define infomation
include wtc_def.inc	;Define
include wtuc_sub.asm	;Sub
include wtuc_cmd.asm	;Command
;===============================================================|
;								|
;		IvV					|
;								|
;===============================================================|
OP_FLAG_ZEMLEN	DB	0			;IvVtO|w
OP_FLAG_HELP	DB	0			;IvVtO|wv\
OP_FLAG_FILE	DB	081H	DUP(00H)	;t@CiPQWj
OP_HELP	DB	0DH,0AH
	DB	"	Wonder Swan Total Sound Driver Un MML Compiler",0DH,0AH
	DB	"			Programmed by  A.Watanabe",0DH,0AH
	DB	0DH,0AH
	DB	"	 [32;4m Filename[32;0m [m"
	DB	"t@C̓ǂݍ",0DH,0AH
	DB	"	>[32;4m Filename[32;0m [m"
	DB	"t@C֏",0DH,0AH
	DB	"	/Z :P̕i1`255j",0DH,0AH
	DB	"	/? :wv̕\",0DH,0AH
	DB	024H
;****************************************************************
;*		IvV					*
;****************************************************************
Op_:
	CALL	OPTION_FLAG		;tO
	MOV	AL,0			;`FbNp
OP_L00:	CMP	CS:[OP_FLAG_ZEMLEN],AL	;ꕪ
	JZ	OP_L01			;
	CALL	OPTION_ZEMLEN		;
OP_L01:	CMP	CS:[OP_FLAG_HELP],AL	;wv\
	JZ	OP_L02			;
	CALL	OPTION_HELP		;
OP_L02:	CMP	CS:[OP_FLAG_FILE],AL	;t@Cǂݍ
	JZ	OP_L03			;
	CALL	OPTION_FILE		;
	jmp	OP_LEE			;
OP_L03:	jmp	COMEND			;t@C̎w肪΁A
OP_LEE:	RET				;RETURN
;****************************************************************
;*		IvVtO				*
;****************************************************************
;	gpWX^						*
;	BX	IvVAhX			*
;	CX	IvVŏIAhX{P		*
;****************************************************************
OPTION_FLAG:				;
	MOV	AX,CS			;
	MOV	DS,AX			;DSCS

	MOV	AX,0000H		;
	MOV	BX,0080H		;BXIvV擪AhX|P
	MOV	AL,CS:[BX]		;ALIvV
	ADD	AX,BX			;
	MOV	CX,AX			;CXI[vVŏIԒn
OP_LOOP:
	INC	BX			;
	CMP	CX,BX			;IvVI
	JNC	OP_LP0			;tOďI
	RET				;
OP_LP0:
	MOV	AL,CS:[BX]		;ǂݍ
	CMP	AL,21H			;
	JC	OP_LOOP			;
	CMP	AL,"/"			;'/'or'-'łAIvV
	JZ	OP_SW			;
	CMP	AL,"-"			;
	JZ	OP_SW			;
	JMP	OP_FILE_SET		;ȊO̓t@Cw
OP_SW:
	INC	BX			;AhXCNg
	CMP	CX,BX			;IvVIH
	JNC	OP_S00			;
	JMP	OPTION_ERROR		;G[
OP_S00:	
	MOV	AH,0FFH			;tOėpB
	MOV	DX,OFFSET OP_FLAG_HELP	;tOAhX
	MOV	AL,CS:[BX]		;
	CMP	AL,"?"			;Help\
	JNZ	OP_S01			;
	JMP	OP_FLAG_SET		;
OP_S01:	CMP	AL,"h"			;
	JNZ	OP_S02			;
	JMP	OP_FLAG_SET		;
OP_S02:	CMP	AL,"H"			;
	JNZ	OP_S03			;
	JMP	OP_FLAG_SET		;
OP_S03:	MOV	DX,OFFSET OP_FLAG_ZEMLEN
	CMP	AL,"z"			;ꕪ
	JNZ	OP_S04			;
	JMP	OP_ZEMLEN_SET		;
OP_S04:	CMP	AL,"Z"			;
	JNZ	OP_S05			;
	JMP	OP_ZEMLEN_SET		;
OP_S05:	
OP_SEE:	JMP	OPTION_ERROR		;G[
;****************************************************************
OP_ZEMLEN_SET:
	INC	BX			;
	PUSH	DX			;
OP_ZEMLEN_SET_1:			;
	MOV	DX,BX			;DXIvVAhX
	CALL	ASC2HEX8		;AHilj
	JC	OP_ZEMLEN_SET_1		;
	DEC	BX			;
	MOV	AL,AH			;ALl
	POP	DX			;
;****************************************************************
OP_FLAG_SET:
	XCHG	BX,DX			;
	MOV	CS:[BX],AL		;tOZbg
	XCHG	BX,DX			;
	JMP	OP_LOOP			;[vɖ߂
;****************************************************************
OP_FILE_SET:
	MOV	DX,OFFSET OP_FLAG_FILE	;t@CׁB
	XCHG	BX,DX			;
	MOV	AH,CS:[BX]		;
	XCHG	BX,DX			;
	CMP	AH,0			;
	JZ	OP_FILE_SET_1		;
	JMP	OPTION_ERROR		;t@CQĂ悧`
OP_FILE_SET_1:
	DEC	BX			;IvV|C^߂
	PUSH	CX			;WX^ۑ
	MOV	CX,080H			;t@Cigq܁jőTCY
OP_FILE_SET_2:
	INC	BX			;
	MOV	AL,CS:[BX]		;ALǂݍ
	CMP	AL,21H			;ŌH
	JC	OP_FILE_SET_3		;
	XCHG	BX,DX			;
	MOV	CS:[BX],AL		;Zbg
	XCHG	BX,DX			;
	INC	DX			;CNg
	DEC	CX			;PQH
	JNZ	OP_FILE_SET_2		;
OP_FILE_SET_3:
	MOV	AL,0			;
	XCHG	BX,DX			;
	MOV	CS:[BX],AL		;'0' Zbg
	XCHG	BX,DX			;
	POP	CX			;WX^A
	JMP	OP_LOOP			;[vɖ߂
;****************************************************************
OPTION_ZEMLEN:				;
	PUSH	AX			;
	MOV	AL,CS:[OP_FLAG_ZEMLEN]	;
	MOV	CS:[D_ZEN],AL		;ݒ
	POP	AX			;
	RET				;RETURN
;****************************************************************
OPTION_HELP:				;
	MOV	DX,OFFSET OP_HELP	;\
	MOV	AH,09H			;
	INT	21H			;
	JMP	COMEND			;vOI
;****************************************************************
OPTION_FILE:				;
	pusha				;

;t@C̃I[v
	MOV	AX,3D00H		;t@C̃I[v
	MOV	DX,OFFSET OP_FLAG_FILE	;DXt@CAhX
	MOV	CX,00H			;
	INT	21H			;axt@Cnh
	jnc	Option_File_ErrOp	;
	jmp	SOPEN_ERROR		;
Option_File_ErrOp:			;
	mov	word ptr cs:[hWtd_File],ax

;t@C̃[h
	PUSH	DS			;
	MOV	AX,word ptr CS:[segWtd_File]
	MOV	DS,AX			;
	MOV	DX,0000H		;
	MOV	CX,0FFFFH		;
	MOV	BX,word ptr CS:[hWtd_File]
	MOV	AH,3FH			;
	INT	21H			;
	POP	DS			;
	JNC	Option_File_ErrLd	;
	JMP	READ_ERROR		;
Option_File_ErrLd:			;

;t@C̃N[Y
	MOV	BX,WORD PTR CS:[hWtd_File]
	MOV	AH,3EH			;
	INT	21H			;
	JNC	Option_File_ErrCl	;
	JMP	CLOSE_ERROR		;
Option_File_ErrCl:			;

	popa				;
	RET				;RETURN
;=======================================================================|
;				main					|
;=======================================================================|
_main:
	MOV	AX,OFFSET WTD_UnMML_Compiler_End + BSTACK	;
	MOV	SP,AX			;

	MOV	AX,CS			;
	MOV	DS,AX			;
	MOV	ES,AX			;ZOgււցB
	MOV	SS,AX			;

	call	ComSmole		;̍ŏ

	call	Memory_Open		;̊m
	call	Op_			;IvV
	call	UnMML_COMPAILE		;tllkRpC
	call	Memory_Close		;̉

_main_End:
COMEND:
	STI				;荞݋
	MOV	AX,04C00H		;
	INT	21H			;MS-DOS RET
;=======================================================================|
;				End					|
;=======================================================================|
WTD_UnMML_Compiler_End:
CODE	ENDS
	END	WTD_UnMML_Compiler_
