;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				define file				|
;					for Assemble Language		|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;****************************************************************
;*								*
;*			}N`				*
;*								*
;****************************************************************
;===============================================================|
;	}N	[NGÃAhX擾		|
;===============================================================|
;	}N						|
;		WTD_WorkGet	reg1,reg2			|
;								|
;		DS	DGROUP					|
;	Ԓl							|
;		reg1	Segment Address				|
;		reg2	Offset  Address				|
;===============================================================|
WTD_WorkGet	macro	seg,off		;
ifdef	library	;------------------------	;@Cuł̂ݕKv

ifdef	IRAM	;---------------		;D-GROUP  I-RAM̏ꍇ
		push	IRAM_Segment		;
		pop	seg			;
		mov	off,offset DGROUP:_WTD_Work

else	;-----------------------		;D-GROUP  S-RAM̏ꍇ
		push	SRAM_Segment		;iWonderWitchj
		pop	seg			;
		mov	off,offset DGROUP:_WTD_Work
endif	;-----------------------

else	;--------------------------------	;WonderWitch
		push	SRAM_Segment		;
		pop	seg			;
		mov	off,ds:[ProcContext_heap]
endif	;--------------------------------
		endm				;

;****************************************************************
;*								*
;*			萔					*
;*								*
;****************************************************************
;===============================================================|
;		n[hEFA荞				|
;===============================================================|
InterruptVectorBase_WW	equ	INT_HARDHAEW_VECTOR_BASE	;WonderWitch
InterruptVectorBase	equ	InterruptVectorBase_WW		;荞݃xN^

;===============================================================|
;		Wander Swan Segment Address			|
;===============================================================|
;ZOgAhX`
IRAM_Segment		equ	0000h			;{RAM
SRAM_Segment		equ	BANK_SRAM_ADDRESS	;SRAM
FROM_Segment		equ	BANK_ROM0_ADDRESS	;ROM

;===============================================================|
;		{RAM Work Address				|
;===============================================================|
;CommEnpty_intvector	equ	000a0h		;荞݃xN^(028h~4)
;Hblank_intvector	equ	000bch		;荞݃xN^(02fh~4)

IRAM_SoundVoiceTable_WW	equ	00180h			;WonderWitchݒ
IRAM_SoundVoiceTable	equ	IRAM_SoundVoiceTable_WW	;Fe[u

;===============================================================|
;		[N̈AhX				|
;===============================================================|
;\̈ʒu
WTD_WorkAdd_User	equ	0000h		;[Up[N
WTD_WorkAdd_Wave	equ	0100h		;F
WTD_WorkAdd_Emb		equ	0200h		;Gx[v
WTD_WorkAdd_System	equ	0380h		;p[gʍ\

WTD_WorkAdd_Ech0	equ	0400h		;Effect ch1
WTD_WorkAdd_Ech1	equ	0480h		;Effect ch2
WTD_WorkAdd_Ech2	equ	0500h		;Effect ch3
WTD_WorkAdd_PCM		equ	0580h		;Effect PCM Voice

WTD_WorkAdd_Ch0		equ	0600h		;ch0
WTD_WorkAdd_Ch1		equ	0680h		;ch1
WTD_WorkAdd_Ch2		equ	0700h		;ch2
WTD_WorkAdd_Ch3		equ	0780h		;ch3
WTD_WorkAdd_Ch4		equ	0800h		;ch4
WTD_WorkAdd_Ch5		equ	0880h		;ch5
WTD_WorkAdd_Ch6		equ	0900h		;ch6
WTD_WorkAdd_Ch7		equ	0980h		;ch7
WTD_WorkAdd_Ch8		equ	0a00h		;ch8
WTD_WorkAdd_Ch9		equ	0a80h		;ch9
WTD_WorkAdd_Ch10	equ	0b00h		;ch10
WTD_WorkAdd_Ch11	equ	0b80h		;ch11
WTD_WorkAdd_Ch12	equ	0c00h		;ch12
WTD_WorkAdd_Ch13	equ	0c80h		;ch13
WTD_WorkAdd_Ch14	equ	0d00h		;ch14
WTD_WorkAdd_Ch15	equ	0d80h		;ch15
WTR_WorkAdd_Ch16	equ	0e00h		;ch16
WTD_WorkAdd_Ch17	equ	0e80h		;ch17
WTD_WorkAdd_Ch18	equ	0f00h		;ch18
WTD_WorkAdd_Ch19	equ	0f80h		;ch19

WTD_WorkChSize		equ	080h		;[ÑTCY
WTD_WorkSize		equ	1000h		;[ÑTCY

WTD_WorkAdd_End		equ	WTD_WorkSize	;[N̍Ō{P

;****************************************************************
;*								*
;*			\̒`				*
;*								*
;****************************************************************
;===============================================================|
;		Micro Soft  RIFF and Wave data formats		|
;===============================================================|
;\̒` RIFF Header
Riff			struc			;
Riff_Head		db	4	dup(?)	;'RIFF'
Riff_Size		dd	?		;File Size(S-8)
Riff_Type		db	4	dup(?)	;'WAVE'
Riff_Data		db	?		;f[^
Riff			ends

;\̒`	RIFF struct
RiffHed			struc			;
RiffHed_Head		db	4	dup(?)	;wb_
RiffHed_Size		dd	?		;wb_̃f[^̃TCY
RiffHed_Data		db	?		;wb_̃f[^
RiffHed			ends			;

;\̒`	WAVE fmt
WaveFmt			struc			;
WaveFmt_Head		db	4	dup(?)	;'fmt '
WaveFmt_Size		dd	?		;16	[byte]
WaveFmt_Type		dw	?		;1	(wave)
WaveFmt_Channel		dw	?		;1	(mono)
WaveFmt_SamplingRate	dd	?		;11025	[Hz]
WaveFmt_SamplingSec	dd	?		;11025	[Byte]
WaveFmt_DataSize	dw	?		;1	[Byte]
WaveFmt_ChannelSize	dw	?		;8	[bit]
WaveFmt			ends			;

;\̒`	WAVE Data
WaveData		struc			;
WaveData_Head		db	4	dup(?)	;'data'
WaveData_Size		dd	?		;Data Size
WaveData_Data		db	?		;wave data
WaveData		ends			;

;===============================================================|
;		p[gʃ[N\				|
;===============================================================|
;\̒萔`
WTD_NoiseMode		equ	WTD_SweepLevel	;
WTD_Voice		equ	WTD_Program	;
WTD_VoiceRate		equ	WTD_ProgramRate	;
WTD_VoiceCnt		equ	WTD_ProgramCnt	;
WTD_Voice1st		equ	WTD_Program1st	;
WTD_Voice2nd		equ	WTD_Program2nd	;
WTD_Voice3rd		equ	WTD_Program3rd	;
WTD_Frection		equ	WTD_Bend	;
WTD_FrectionSet		equ	WTD_BendSet	;
WTD_Velocity		equ	WTD_ExprPanSet	;
WTD_PcmAddress		equ	WTD_LoopCount	;AhX
WTD_PcmSize		equ	WTD_LoopCount+4	;IAhX
;---------------------------------------------------------------
;p[gʍ\̒`
WTD			struc			;ep[gʗp	
WTD_FlagControl		dw	?		;00-01	tO
WTD_FlagTai		db	?		;02	^CtO
WTD_FlagSharp		db	?		;03	#tO
WTD_FlagFlat		db	?		;04	btO
WTD_Channel		db	?		;05	/ׯ
WTD_Address		dw	?		;06-07	ṯڽ
WTD_LoopCount		db	8	dup(?)	;08-0F	[v/PCM Address
WTD_LoopCountPointer	db	?		;10	L߲
WTD_Program		db	?		;11	o͂F
WTD_SweepLevel		db	?		;12	ߒl/ɲӰ
WTD_SweepTime		db	?		;13	ߎ
WTD_Leng		dw	?		;14-15	
WTD_LengCounter		dw	?		;16-17	JE^[
WTD_LengDefault		dw	?		;18-19	̫Ẳ
WTD_KeyOffTime		dw	?		;1A-1B	ްѐl
WTD_KeyOnDelay		dw	?		;1C-1D	ިڲ
WTD_KeyShift		db	?		;1E	ڒl
WTD_Key			db	?		;1F	
WTD_KeySet		db	8	dup(?)	;20-27	o͂
WTD_KeySetPointer	db	?		;28	L߲
WTD_AcsentVelocity	db	?		;29	ANZgl
WTD_BendSet		dw	?		;2A-2B	o͂g
WTD_Bend		dw	?		;2C-2D	wg
WTD_BendDetune		dw	?		;2E-2F	fB`[
WTD_BendLfoDecayRate	db	?		;30	LFOfBPCCg
WTD_BendLfoSpeedRate	db	?		;31	LFOXs[h
WTD_BendLfoLevel	dw	?		;32-33	LFOψ
WTD_BendLfoCount	db	?		;34	LFOω
WTD_BendLfoRateCounter	db	?		;35	LFOCgpJE^
WTD_BendLfoLevelSet	dw	?		;36-37	LFO݂̕ψ
WTD_BendLfoCountCounter	db	?		;38	LFO񐔗pJE^
WTD_BendEmbAddress	db	?		;39	EMBԍiڽj
WTD_BendEmbRate		db	?		;3A	EMBCg
WTD_BendEmbCounter	db	?		;3B	EMBJE^[
WTD_BendEmbMaxMin	db	?		;3C	EMBő^ŏl
WTD_BendEmbLevelSet	db	?		;3D	EMBψ
WTD_ReleaseVolume	db	?		;3E	KeyOff̉
WTD_ExprPanSet		db	?		;3F	o/ުۼè
WTD_ExprSet		db	?		;40	o͉/گ
WTD_Expr		db	?		;41	/گ
WTD_ExprDetune		dw	?		;42-43	ʑl
WTD_ExprLfoDecayRate	db	?		;44	LFOfBPCCg
WTD_ExprLfoSpeedRate	db	?		;45	LFOXs[h
WTD_ExprLfoLevel	dw	?		;46-47	LFOψ
WTD_ExprLfoCount	db	?		;48	LFOω
WTD_ExprLfoRateCounter	db	?		;49	LFOCgpJE^
WTD_ExprLfoLevelSet	dw	?		;4A-4B	LFO݂̕ψ
WTD_ExprLfoCountCounter	db	?		;4C	LFO񐔗pJE^
WTD_ExprEmbAddress	db	?		;4D	EMBԍiڽj
WTD_ExprEmbRate		db	?		;4E	EMBCg
WTD_ExprEmbCounter	db	?		;4F	EMBJE^[
WTD_ExprEmbMaxMin	db	?		;50	EMBő^ŏl
WTD_ExprEmbLevelSet	db	?		;51	EMBψ
WTD_WorkAddress		db	?		;52	[Nڽ8BIT
WTD_OctaveSet		db	?		;53	o͂IN^[u
WTD_Octave		db	?		;54	wIN^[u
WTD_GateTime8		db	?		;55	ްсiQ,U)
WTD_GateTimeStepLast	dw	?		;56-57	ް(q)
WTD_GateTimeStepFirst	dw	?		;58-59	ް(u)
WTD_VolumeUpDown	db	?		;5A	΃{[̑l
WTD_ModDecay		dw	?		;5B-5C	Ӽޭڰ ިڲ
WTD_ModLevel		db	?		;5D	Ӽޭڰ 
WTD_ModLevelSet		db	?		;5E	݂Ӽޭڰ 
WTD_Null_5F		db	?		;5F	gp
WTD_PanSet		db	?		;60	o̓p|bg
WTD_Pan			db	?		;61	p|bg
WTD_PanDetune		dw	?		;62-63	ʑl
WTD_PanLfoDecayRate	db	?		;64	LFOfBPCCg
WTD_PanLfoSpeedRate	db	?		;65	LFOXs[h
WTD_PanLfoLevel		dw	?		;66-67	LFOψ
WTD_PanLfoCount		db	?		;68	LFOω
WTD_PanLfoRateCounter	db	?		;69	LFOCgpJE^
WTD_PanLfoLevelSet	dw	?		;6A-6B	LFO݂̕ψ
WTD_PanLfoCountCounter	db	?		;6C	LFO񐔗pJE^
WTD_PanEmbAddress	db	?		;6D	EMBԍiڽj
WTD_PanEmbRate		db	?		;6E	EMBCg
WTD_PanEmbCounter	db	?		;6F	EMBJE^[
WTD_PanEmbMaxMin	db	?		;60	EMBő^ŏl
WTD_PanEmbLevelSet	db	?		;61	EMBψ
WTD_ProgramRate		dw	?		;62-63	FςB
WTD_Program1st		db	?		;64	F̏l
WTD_Program2nd		db	?		;65	oω
WTD_Program3rd		db	?		;66	KeyOff㉹F
WTD_ProgramDecay	db	?		;67	oωQ
WTD_ProgramDecayRate	dw	?		;68-69	FςQ

WTD			ends
;---------------------------------------------------------------
;\̈ʒu
WTD_BendLFO		equ	WTD_BendLfoDecayRate	;ChLFO\̐擪
WTD_ExprLFO		equ	WTD_ExprLfoDecayRate	;ChLFO\̐擪
WTD_PanLFO		equ	WTD_PanLfoDecayRate	;ChLFO\̐擪
WTD_BendEmb		equ	WTD_BendEmbAddress	;ChEmb\̐擪
WTD_ExprEmb		equ	WTD_ExprEmbAddress	;ChEmb\̐擪
WTD_PanEmb		equ	WTD_PanEmbAddress	;ChEmb\̐擪

;ChLFO\
WTD_ChLfo		struc
WTD_ChLfo_DecayRate	db	?		;	LFOfBPCCg
WTD_ChLfo_SpeedRate	db	?		;	LFOXs[h
WTD_ChLfo_Level		dw	?		;	LFOψ
WTD_ChLfo_Count		db	?		;	LFOω
WTD_ChLfo_RateCounter	db	?		;	LFOCgpJE^
WTD_ChLfo_LevelSet	dw	?		;	LFO݂̕ψ
WTD_ChLfo_CountCounter	db	?		;	LFO񐔗pJE^
WTD_ChLfo		ends
;ChEmb\
WTD_ChEmb		struc
WTD_ChEmb_Address	db	?		;	EMBԍiڽj
WTD_ChEmb_Rate		db	?		;	EMBCg
WTD_ChEmb_Counter	db	?		;	EMBJE^[
WTD_ChEmb_MaxMin	db	?		;	EMBő^ŏl
WTD_ChEmb_LevelSet	db	?		;	EMBψ
WTD_ChEmb		ends
;---------------------------------------------------------------
;tOrbgEZbg
WTD_Ctrl_BendLfo	equ	00001h		;kenXCb`
WTD_Ctrl_BendEmb	equ	00002h		;Gx[vXCb`
WTD_Ctrl_ExprLfo	equ	00004h		;ʂkenXCb`
WTD_Ctrl_ExprEmb	equ	00008h		;ʃGx[vXCb`
WTD_Ctrl_PanLfo		equ	00010h		;pkenXCb`
WTD_Ctrl_PanEmb		equ	00020h		;pGx[vXCb`
WTD_Ctrl_Acsent		equ	00040h		;̉K̓ANZg
WTD_Ctrl_EmbFreq	equ	00080h		;Gx[v bit
WTD_Ctrl_EmbVol		equ	00100h		;ʃGx[v bit
WTD_Ctrl_EmbPan		equ	00200h		;pGx[v bit
WTD_Ctrl_Vol0		equ	00400h		;ʁO & Relase
WTD_Ctrl_WorkSw		equ	00800h		;̃R}h́A[NQ
WTD_Ctrl_WorkCy		equ	01000h		;[NZʁAI[o[t[
WTD_Ctrl_WorkZe		equ	02000h		;[NZʁAOɂȂB
WTD_Ctrl_Effect		equ	04000h		;̃p[g͌ʉH
WTD_Ctrl_PlayEnd	equ	08000h		;tI
;---------------------------------------------------------------
;tOrbgEZbg
WTD_Ctrl_BendLfoR	equ	0fffeh		;kenXCb`
WTD_Ctrl_BendEmbR	equ	0fffdh		;Gx[vXCb`
WTD_Ctrl_ExprLfoR	equ	0fffbh		;ʂkenXCb`
WTD_Ctrl_ExprEmbR	equ	0fff7h		;ʃGx[vXCb`
WTD_Ctrl_PanLfoR	equ	0ffefh		;pkenXCb`
WTD_Ctrl_PamEmbR	equ	0ffdfh		;pGx[vXCb`
WTD_Ctrl_AcsentR	equ	0ffbfh		;̉K̓ANZg
WTD_Ctrl_EmbFreqR	equ	0ff7fh		;Gx[v bit
WTD_Ctrl_EmbVolR	equ	0feffh		;ʃGx[v bit
WTD_Ctrl_EmbPanR	equ	0fdffh		;pGx[v bit
WTD_Ctrl_Vol0R		equ	0fbffh		;ʁO & Relase
WTD_Ctrl_WorkSwR	equ	0f7ffh		;̃R}h́A[NQ
WTD_Ctrl_WorkCyR	equ	0efffh		;[NZʁAI[o[t[
WTD_Ctrl_WorkZeR	equ	0dfffh		;[NZʁAOɂȂB
WTD_Ctrl_EffectR	equ	0bfffh		;̃p[g͌ʉH
WTD_Ctrl_PlayEndR	equ	07fffh		;tI

;===============================================================|
;		p[gʃ[N\				|
;===============================================================|
WTD_Sys			struc			;VXeS	
WTD_Sys_Flag		dw	?		;00	Flag
WTD_Sys_ProgramOffset	dw	?		;02	Program Offset Address
WTD_Sys_ProgramSegment	dw	?		;04	Program Segment Address
WTD_Sys_MusicOffset	dw	?		;06	Music Offset Address
WTD_Sys_MusicSegment	dw	?		;08	Music Segment Address
WTD_Sys_EffectOffset	dw	?		;0a	Effect Offset Address
WTD_Sys_EffectSegment	dw	?		;0c	Effect Segment Address
WTD_Sys_PcmOffset	dw	?		;0e	Pcm Offset Address
WTD_Sys_PcmSegment	dw	?		;10	Pcm Segment Address
WTD_Sys_StayOutMask	dw	?		;12	풓֎~
WTD_Sys_OldIntvector	dw	2	dup(?)	;14-17	O̊荞݃xN^
WTD_Sys_OldIntvectorCom	dw	2	dup(?)	;18-1B	O̊荞݃xN^
WTD_Sys_ComFIFO_Offset	dw	?		;1C-1D	FIFO Offset Address
WTD_Sys_ComFIFO_Segment	dw	?		;1E-1F	FIFO Segment Address
WTD_Sys_Null_20		db	?		;20	gp
WTD_Sys_VolumeMusic	db	?		;21	\tgEFA t
WTD_Sys_VolumeEffect	db	?		;22	\tgEFA ʉ
WTD_Sys_VolumePCM	db	?		;23	\tgEFA PCM
WTD_Sys_Tempo		dw	?		;24	e|
WTD_Sys_TempoCounter	dw	?		;26	e|JE^
WTD_Sys_MusicPart	db	?		;28	t̃p[g(ő20)
WTD_Sys_EffectPart	db	?		;29	ʉ̃p[g(ő3)
WTD_Sys_ComFIFO_Cnt	dw	?		;2A-2B	FIFO |C^ 
WTD_Sys_ComFIFO_Adr	dw	?		;2C-2D	FIFO |C^ M
WTD_Sys_ComFIFO_Size	dw	?		;2E-2F	FIFO TCY
WTD_Sys_RunningStatus	db	?		;30	MIDI Running Status
WTD_Sys_InterruptBase	db	?		;31	荞݃x[XxN^
WTD_Sys_VoiceTableOffset dw	?		;32	FTable(IRAM)Address
WTD_Sys			ends			
;---------------------------------------------------------------
;tOrbgEZbg
WTD_Sys_Music		equ	00001h		;t
WTD_Sys_Effect		equ	00002h		;ʉ
WTD_Sys_Pcm		equ	00004h		;PCM{CX
WTD_Sys_3		equ	00008h		;	(FPCM VoiceI)
WTD_Sys_Midi		equ	00010h		;MIDI[h(VXeł͖gp)
WTD_Sys_5		equ	00020h		;
WTD_Sys_6		equ	00040h		;
WTD_Sys_TimerEmulate	equ	00080h		;^C}[G~[g
WTD_Sys_ChannelMode1	equ	00100h		;`l[h ch1
WTD_Sys_ChannelMode2	equ	00200h		;`l[h ch2
WTD_Sys_ChannelMode3	equ	00400h		;`l[h ch3
WTD_Sys_ChannelMode4	equ	00800h		;`l[h ch4
WTD_Sys_EffectMask1	equ	01000h		;ʉp[g}XN ch1
WTD_Sys_EffectMask2	equ	02000h		;ʉp[g}XN ch2
WTD_Sys_EffectMask3	equ	04000h		;ʉp[g}XN ch3
WTD_Sys_EffectMask4	equ	08000h		;ʉp[g}XN ch4
;---------------------------------------------------------------
;tOrbgEZbg
WTD_Sys_MusicR		equ	0fffeh		;t
WTD_Sys_EffectR		equ	0fffdh		;ʉ
WTD_Sys_PcmR		equ	0fffbh		;PCM{CX
WTD_Sys_3R		equ	0fff7h		;	(FPCM VoiceI)
WTD_Sys_MidiR		equ	0ffefh		;MIDI[h(VXeł͖gp)
WTD_Sys_5R		equ	0ffdfh		;
WTD_Sys_6R		equ	0ffbfh		;
WTD_Sys_TimerEmulateR	equ	0ff7fh		;^C}[G~[g
WTD_Sys_ChannelMode1R	equ	0feffh		;`l[h ch1
WTD_Sys_ChannelMode2R	equ	0fdffh		;`l[h ch2
WTD_Sys_ChannelMode3R	equ	0fbffh		;`l[h ch3
WTD_Sys_ChannelMode4R	equ	0f7ffh		;`l[h ch4
WTD_Sys_EffectMask1R	equ	0efffh		;ʉp[g}XN ch1
WTD_Sys_EffectMask2R	equ	0dfffh		;ʉp[g}XN ch2
WTD_Sys_EffectMask3R	equ	0bfffh		;ʉp[g}XN ch3
WTD_Sys_EffectMask4R	equ	07fffh		;ʉp[g}XN ch4

;===============================================================|
;		\tgEFAGx[v\			|
;===============================================================|
WTD_Emb			struc
WTD_Emb_AR		db	?		;00h	:Attack Rate
WTD_Emb_AS		db	?		;01h	:Attack Speed (001h)
WTD_Emb_AL		db	?		;02h	:Attack Level (0FFh)
WTD_Emb_FL		db	?		;03h	:First Level
WTD_Emb_DR		db	?		;04h	:Decay Rate
WTD_Emb_DS		db	?		;05h	:Decay Speed (081h)
WTD_Emb_DL		db	?		;06h	:Decay Level
WTD_Emb_Null1		db	?		;07h	:gp
WTD_Emb_SR		db	?		;08h	:Sustain Rate
WTD_Emb_SS		db	?		;09h	:Sustain Speed (081h)
WTD_Emb_SL		db	?		;0Ah	:Sustain Level (000h)
WTD_Emb_Null2		db	?		;0Bh	:gp
WTD_Emb_RR		db	?		;0Ch	:Relase Rate
WTD_Emb_RS		db	?		;0Dh	:Relase Speed (081h)
WTD_Emb_RL		db	?		;0Eh	:Relase Level (000h)
WTD_Emb_Null3		db	?		;0Fh	:gp
WTD_Emb			ends				

;===============================================================|
;			ȃf[^\				|
;===============================================================|
WTD_Mus			struc
WTD_Mus_Name		db	4	dup(?)	;00-03h	:Iʎq
WTD_Mus_Version		dw	?		;04-05h	:Version
WTD_Mus_Extr		dw	?		;06-07h	:gwb_TCY
WTD_Mus_Emb		db	?		;08h	:Gx[v
WTD_Mus_Voice		db	?		;09h	:g`f[^
WTD_Mus_Part		db	?		;0Ah	:p[g
WTD_Mus_TimeBase	db	?		;0Bh	:S̕
WTD_Mus_ExtrAdr		dw	?		;0Ch	:gwb_̃AhX
WTD_Mus_DataAdr		dw	?		;0Eh	:f[^̃AhX
WTD_Mus_PartAdr		dw	?		;10h	:ȃf[^AhX
WTD_Mus			ends

;===============================================================|
;			gwb_[\̒`			|
;===============================================================|
WTD_MusEx		struc
;
;			݁Agp
;
WTD_MusEx		ends

