;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Un MML Compiler Program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|

.186
.model	tiny,stdcall

;=======================================================================|
;				define					|
;=======================================================================|

include	lib_dos.inc

.dosseg

.stack	1000h

.data

OP_FLAG_LEN	DB	4			;IvVtO|w

.data?

segWtd_File	dw	?
szWtd_File	dw	?

;=======================================================================|
;				Start Up				|
;=======================================================================|
.code
	.startup
	mov	ax,cs
	mov	ss,ax
	mov	sp,offset DGROUP:STACK
	invoke	ComSmole,	sp	;̍ŏ

	cld

	call	_main

	.exit	0

;---------------------------------------------------------------|
;		G[					|
;---------------------------------------------------------------|
;								|
;	dx	\iG[ej			|
;---------------------------------------------------------------|
PRINT_ERR:
	push	cs			;
	pop	ds			;
	MOV	AH,09H			;
	INT	21H			;
	.exit	255			;

;=======================================================================|
;				Start					|
;=======================================================================|
include	wtd_ver.inc	;WTD Version infomation
include	wtd_def.inc	;WTD Define infomation
;include	DAT2ASM.INC	;
include	D2A_CNV.ASM	;convert routine
;===============================================================|
;								|
;		IvV					|
;								|
;===============================================================|
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OPTION_ERROR_MSG	db	'IvVsłB',0dh,0ah,24h
.code
OPTION_ERROR	proc	near
	lea	dx,[OPTION_ERROR_MSG]
	jmp	PRINT_ERR
OPTION_ERROR	endp
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OP_HELP	DB	0DH,0AH
	DB	"	Converter from a binary to a DB command",0DH,0AH
	DB	"			Programmed by  A.Watanabe",0DH,0AH
	DB	0DH,0AH
	DB	"	 [32;4m Filename[32;0m [m"
	DB	"t@C̓ǂݍ",0DH,0AH
	DB	"	>[32;4m Filename[32;0m [m"
	DB	"t@C֏",0DH,0AH
	DB	"	/B : DBߏóiBytej",0DH,0AH
	DB	"	/W : DWߏóiWordj",0DH,0AH
	DB	"	/D : DDߏóiDouble Wordj",0DH,0AH
	DB	"	/? :wv̕\",0DH,0AH
	DB	024H
.code
OPTION_HELP	proc	near
	push	cs
	pop	ds
	lea	DX,[OP_HELP]		;\
	MOV	AH,09H			;
	INT	21H			;
	.exit	0
OPTION_HELP	endp			;
;****************************************************************
;*		IvV					*
;****************************************************************
;								*
;	ptFilename	t@C|C^		*
;Ԃl							*
;	ptFilename[]	IvVŎw肳ꂽt@C	*
;gpWX^							*
;	ds:si		IvVAhX		*
;	es:di		ptFilename				*
;	ax		ėp					*
;	cx		IvVŏIAhX{P	*
;****************************************************************
.code
Op_	proc	near	uses ds es,
		ptFilename:DWORD	;t@C|C^

	local	cDebug:BYTE		;fobO̐ݒL
	local	cHelp:BYTE		;wv\̗L
	local	dotFlag:BYTE		;t@C̊gq̗L

	pusha

	;-----------------------
	;tO
	xor	ax,ax			;ax  0
	les	di,ptFilename		;
	stosb				;擪ɂA0ĂB
	mov	cDebug,al		;
	mov	cHelp,al		;
	mov	dotFlag,al		;

	push	cs			;
	pop	ds			;DSCS
	MOV	si,0080H		;BXIvV擪AhX|P
	lodsb				;ALIvV
	ADD	ax,si			;
	MOV	cx,ax			;CXI[vVŏIԒn

    .while	(cx>=si)

	lodsb

	.if	(al<21h)
		.continue

	.elseif	((al=='/')||(al=='-'))
		.if	(cx<si)
			JMP	OPTION_ERROR	;G[
		.endif

		lodsb
		.if	((al=='h')||(al=='H')||(al=='?'))
			mov	cHelp,0FFh
		.elseif	((al=='b')||(al=='B'))
			mov	OP_FLAG_LEN, 1
		.elseif	((al=='w')||(al=='W'))
			mov	OP_FLAG_LEN, 2
		.elseif	((al=='d')||(al=='D'))
			mov	OP_FLAG_LEN, 4
		.else
			JMP	OPTION_ERROR	;G[
		.endif

	.else
		les	di,ptFilename		;t@C|C^
		.if	(byte ptr es:[di] != 0)
			JMP	OPTION_ERROR	;t@CQĂ悧`
		.endif

		dec	si			;|C^߂
		mov	dotFlag,0
		.while	(cx>=si)
			lodsb
			.if	(al == '.')
				mov	dotFlag,1
			.elseif	(al < 21h)
				dec	si
				.break		;21hIB
			.endif
			stosb			;t@CZbg
		.endw

		.if	(dotFlag==0)		;gq`Ȃ`
			mov	al,'.'
			stosb
			mov	al,'W'		;".WTD"ɂBꉞA啶ŁB
			stosb
			mov	al,'T'
			stosb
			mov	al,'D'
			stosb
		.endif

		mov	al,0			;
		stosb
		mov	al,24h			;
		stosb
	.endif

    .endw

	;-----------------------
	;tOɉ
	;wv
	.if	(cHelp != 0)
		jmp	OPTION_HELP		;
	.endif

	;t@C
	les	di,ptFilename			;t@C|C^
	.if	(byte ptr es:[di] != 0)
		invoke	Change_Current_Directory,	addr es:[di]

		;I[v
		invoke	File_Open,			addr es:[di],	0
		push	ax

		;[h
		mov	ds,word ptr CS:[segWtd_File]
		invoke	File_Load,	ax,addr ds:0
		mov	word ptr CS:[szWtd_File],ax

		;N[Y
		pop	ax
		invoke	File_Close,	ax
	.else
		jmp	OPTION_HELP	;t@C̎w肪΁A
	.endif

	popa
	RET				;RETURN
Op_	endp
;=======================================================================|
;				main					|
;=======================================================================|
_main	proc	near

	local	cFilename[134]:BYTE		;t@C

	;-------------------------------
	;I[v
	invoke	Memory_Open,	01000h	;
	mov	word ptr cs:[segWtd_File],ax
	mov	es,ax				;DSWTD SEGMENT

	;-------------------------------
	;IvV
	invoke	Op_,	addr ss:cFilename	;IvVɋLqꂽt@C擾B

	;-------------------------------
	;RpC
	invoke	convert				;

	;-------------------------------
	;̉
	invoke	Memory_Close,	es

	ret
_main	endp
;=======================================================================|
;				End					|
;=======================================================================|
	END
