;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				MML Compiler Program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|

.186
.model	tiny,stdcall

;=======================================================================|
;				define					|
;=======================================================================|

include	lib_dos.inc

.dosseg

.stack	1000h

.data?

pWSC_File	dw	?	;AhXǗ(p)

;=======================================================================|
;				Start Up				|
;=======================================================================|
.code
	.startup
	mov	ax,cs
	mov	ss,ax
	mov	sp,offset DGROUP:STACK
	invoke	ComSmole,	sp	;̍ŏ

	cld

	call	_main

	.exit	0

;---------------------------------------------------------------|
;		G[					|
;---------------------------------------------------------------|
;								|
;	dx	\iG[ej			|
;---------------------------------------------------------------|
PRINT_ERR:
	push	cs			;
	pop	ds			;
	MOV	AH,09H			;
	INT	21H			;
	.exit	255			;

;=======================================================================|
;				Start					|
;=======================================================================|
include	wtd_ver.inc	;WTD Version infomation
include	wtd_def.inc	;WTD Define infomation
;include	WSMAKE.INC	;
;===============================================================|
;								|
;		IvV					|
;								|
;===============================================================|
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OPTION_ERROR_MSG	db	'IvVsłB',0dh,0ah,24h
.code
OPTION_ERROR	proc	near
	lea	dx,[OPTION_ERROR_MSG]
	jmp	PRINT_ERR
OPTION_ERROR	endp
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OP_HELP	DB	0DH,0AH
	DB	"	WonderSwan ROM image maker",0DH,0AH
	DB	"			Programmed by  A.Watanabe",0DH,0AH
	DB	0DH,0AH
	DB	"	 [32;4m Filename[32;0m [m"
	DB	"t@C̓ǂݍ",0DH,0AH
	DB	"	/? :wv̕\",0DH,0AH
	DB	024H
.code
OPTION_HELP	proc	near
	push	cs
	pop	ds
	lea	DX,[OP_HELP]		;\
	MOV	AH,09H			;
	INT	21H			;
	.exit	0
OPTION_HELP	endp			;
;****************************************************************
;*		IvV					*
;****************************************************************
;								*
;	ptFilename	t@C|C^		*
;Ԃl							*
;	ptFilename[]	IvVŎw肳ꂽt@C	*
;gpWX^							*
;	ds:si		IvVAhX		*
;	es:di		ptFilename				*
;	ax		ėp					*
;	cx		IvVŏIAhX{P	*
;****************************************************************
.code
Op_	proc	near	uses ds es,
		ptFilename:DWORD	;t@C|C^

	local	cHelp:BYTE		;wv\̗L
	local	dotFlag:BYTE		;t@C̊gq̗L

	pusha

	;-----------------------
	;tO
	xor	ax,ax			;ax  0
	les	di,ptFilename		;
	stosb				;擪ɂA0ĂB
	mov	cHelp,al		;
	mov	dotFlag,al		;

	push	cs			;
	pop	ds			;DSCS
	MOV	si,0080H		;BXIvV擪AhX|P
	lodsb				;ALIvV
	ADD	ax,si			;
	MOV	cx,ax			;CXI[vVŏIԒn

    .while	(cx>=si)

	lodsb

	.if	(al<21h)
		.continue

	.elseif	((al=='/')||(al=='-'))
		.if	(cx<si)
			JMP	OPTION_ERROR	;G[
		.endif

		lodsb
		.if	((al=='h')||(al=='H')||(al=='?'))
			mov	cHelp,0FFh
		.else
			JMP	OPTION_ERROR	;G[
		.endif

	.else
		les	di,ptFilename		;t@C|C^
		.if	(byte ptr es:[di] != 0)
			JMP	OPTION_ERROR	;t@CQĂ悧`
		.endif

		dec	si			;|C^߂
		mov	dotFlag,0
		.while	(cx>=si)
			lodsb
			.if	(al == '.')
				mov	dotFlag,1
			.elseif	(al < 21h)
				dec	si
				.break		;21hIB
			.endif
			stosb			;t@CZbg
		.endw

		.if	(dotFlag==0)		;gq`Ȃ`
			mov	al,'.'
			stosb
			mov	al,'W'		;".WTD"ɂBꉞA啶ŁB
			stosb
			mov	al,'T'
			stosb
			mov	al,'D'
			stosb
		.endif

		mov	al,0			;
		stosb
		mov	al,24h			;
		stosb
	.endif

    .endw

	;-----------------------
	;tOɉ
	;wv
	.if	(cHelp != 0)
		jmp	OPTION_HELP		;
	.endif

	;t@C
	les	di,ptFilename			;t@C|C^
	.if	(byte ptr es:[di] != 0)
		invoke	Change_Current_Directory,	addr es:[di]

		;I[v
		invoke	File_Open,			addr es:[di],	0
		push	ax

		;[h
		mov	ds,word ptr CS:[pWSC_File]
		invoke	File_Load,	ax,addr ds:0

		;N[Y
		pop	ax
		invoke	File_Close,	ax
	.else
		jmp	OPTION_HELP	;t@C̎w肪΁A
	.endif

	popa
	RET				;RETURN
Op_	endp
;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				MML Compiler Program			|
;				Main Routine				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
.const
BIOS_FILE	db	'ROM_IMG.BIN',0,0ah,0dh,24h
MUS_ERR		db	'WTD`̃f[^ł͂܂B'

WSR_HEAD	db	"WSRF"
		dw	0100h
		db	10	dup(0)
WSC_HEAD	db	0EAh
		dw	00000h
		dw	0F000h
		db	11	dup(0)
.code
_main	proc	near

	local	Ext[3]:BYTE		;gq@ύXp
	local	cFilename[134]:BYTE	;t@C

		;-------------------------------
		;I[v
		invoke	Memory_Open,	02000h	;
		mov	word ptr cs:[pWSC_File],ax
		mov	es,ax			;ESMML SEGMENT
		mov	di,0			;es:di mۂZOg
		mov	cx,08000h		;
		mov	ax,0			;
	rep	stosw				;O
		mov	ax,es			;
		add	ax,01000h		;
		mov	es,ax			;
		mov	di,0			;es:di mۂZOg
		mov	cx,08000h		;
		mov	ax,0			;
	rep	stosw				;O

		;-----------------------
		;ƎBIOS̓ǂݍ

		;file_open(ROM_IMG.BIN)
		invoke	File_Open,	addr cs:[BIOS_FILE],	0
		push	ax

		invoke	File_Load,	ax, addr es:0

		;N[Y
		pop	ax
		invoke	File_Close,	ax


		;-------------------------------
		;IvV  t@Cǂݍ
		invoke	Op_,	addr ss:cFilename	;IvVɋLqꂽt@C擾B


		;-----------------------
		;Wonder Swan ROM ݒ
		push	cs
		pop	ds
		lea	si, WSR_HEAD
		mov	di, 0FFE0h
		mov	cx, 00010h
	rep	movsw

		;-----------------------
		;ROMC[W̍쐬

		;WTD``FbN		;
		push	cs:[pWSC_File]		;
		pop	ds			;
		xor	dx, dx			;ds:dx mۂZOg
		xor	bx, bx
		.if	(word ptr ds:[bx] != 'TW')
		   mov	dx, 80h
		   mov	bx, dx
		   .if	(word ptr ds:[bx] != 'TW')
			lea	dx, MUS_ERR
			jmp	PRINT_ERR
		   .endif
		.endif

		;file_open("*.WSC")
		mov	Ext[0],'W'		;
		mov	Ext[1],'S'		;gq"WTD"
		mov	Ext[2],'C'		;
		invoke	ChangeExt,	addr ss:cFilename,addr ss:Ext

		invoke	File_Create,	addr ss:cFilename,0

		;@File_Write() ́A ax 󂳂Ȃ

		mov	cx, 8000h
		invoke	File_Write,	ax, cx, ds::dx
		add	dx, cx
		invoke	File_Write,	ax, cx, ds::dx
		xor	dx, dx
		invoke	File_Write,	ax, cx, es::dx
		invoke	File_Write,	ax, cx, es::cx

		invoke	File_Close,	ax

		ret
_main	endp
;=======================================================================|
;				End					|
;=======================================================================|
	END
