;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				MML Compiler Program			|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|

.186
.model	tiny,stdcall

;=======================================================================|
;				define					|
;=======================================================================|

include	lib_dos.inc

.dosseg

.stack	1000h

.data
WtdIL_Name		equ	'WTD',0
MusicMaxPart		equ	20	;ił20p[g
EffectMaxPart		equ	3	;ʉ3 p[g

D_Debug			DB	00h		;fobOtO

;=======================================================================|
;				Start Up				|
;=======================================================================|
.code
	.startup
	mov	ax,cs
	mov	ss,ax
	mov	sp,offset DGROUP:STACK
	invoke	ComSmole,	sp	;̍ŏ

	cld

	call	_main

	.exit	0

;---------------------------------------------------------------|
;		G[					|
;---------------------------------------------------------------|
;								|
;	dx	\iG[ej			|
;---------------------------------------------------------------|
PRINT_ERR:
	push	cs			;
	pop	ds			;
	MOV	AH,09H			;
	INT	21H			;
	.exit	255			;

;=======================================================================|
;				Start					|
;=======================================================================|
.code
include bank.inc	;oN
include wtd_ver.inc	;WTD Version infomation
include wtd_def.inc	;WTD Define infomation
include wtc_def.inc	;Define

include sub_cnv.asm	;10i 16i ϊ
include wtc_hed.asm	;Header
include wtc_voi.asm	;Voice & Emb
include wtc_com.asm	;Command

;===============================================================|
;								|
;		IvV					|
;								|
;===============================================================|
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OPTION_ERROR_MSG	db	'IvVsłB',0dh,0ah,24h
.code
OPTION_ERROR	proc	near
	lea	dx,[OPTION_ERROR_MSG]
	jmp	PRINT_ERR
OPTION_ERROR	endp
;****************************************************************
;*		IvVtO				*
;****************************************************************
.const
OP_HELP		DB	0DH,0AH
		DB	'Wonder Swan Total Souund Driver',0Dh,0Ah
		DB	'Version ', WtdIL_Version
		DB	0DH,0AH
		DB	0DH,0AH
		DB	"WTC [/?] [filename]",0DH,0AH
		DB	0DH,0AH
		DB	"   filename	Source MML filename",0DH,0AH
;		DB	"  /D		Set the debug mode (0 to 255)",0DH,0AH
;		db	"  mode		 bit0(+  1) : reserve",0DH,0AH
;		db	"		 bit2(+  4) : reserve",0DH,0AH
;		db	"		 bit3(+  8) : reserve",0DH,0AH
;		db	"		 bit4(+ 16) : reserve",0DH,0AH
;		db	"		 bit5(+ 32) : reserve",0DH,0AH
;		db	"		 bit6(+ 64) : reserve",0DH,0AH
;		db	"		 bit7(+128) : CN[hWJMMLo͂B",0DH,0AH
;		db	"		 default = 0",0dh,0ah
		DB	"  /?		Display help",0DH,0AH
		DB	024H
.code
OPTION_HELP	proc	near
	push	cs
	pop	ds
	lea	DX,[OP_HELP]		;\
	MOV	AH,09H			;
	INT	21H			;
	.exit	0
OPTION_HELP	endp			;
;****************************************************************
;*		IvV					*
;****************************************************************
;								*
;	ptFilename	t@C|C^		*
;Ԃl							*
;	ptFilename[]	IvVŎw肳ꂽt@C	*
;gpWX^							*
;	ds:si		IvVAhX		*
;	es:di		ptFilename				*
;	ax		ėp					*
;	cx		IvVŏIAhX{P	*
;****************************************************************
.code
Op_	proc	near	uses ds es,
		ptFilename:DWORD	;t@C|C^

	local	cDebug:BYTE		;fobO̐ݒL
	local	cHelp:BYTE		;wv\̗L
	local	dotFlag:BYTE		;t@C̊gq̗L

	pusha

	;-----------------------
	;tO
	xor	ax,ax			;ax  0
	les	di,ptFilename		;
	stosb				;擪ɂA0ĂB
	mov	cDebug,al		;
	mov	cHelp,al		;
	mov	dotFlag,al		;

	push	cs			;
	pop	ds			;DSCS
	MOV	si,0080H		;BXIvV擪AhX|P
	lodsb				;ALIvV
	ADD	ax,si			;
	MOV	cx,ax			;CXI[vVŏIԒn

    .while	(cx>=si)

	lodsb

	.if	(al<21h)
		.continue

	.elseif	((al=='/')||(al=='-'))
		.if	(cx<si)
			JMP	OPTION_ERROR	;G[
		.endif

		lodsb
		.if	((al=='h')||(al=='H')||(al=='?'))
			mov	cHelp,0FFh
		.elseif	((al=='d')||(al=='D'))
		   .repeat
			mov	dx,si		;DXIvVAhX
			.if	(cx<dx)		;G[
				JMP	OPTION_ERROR
			.endif
			CALL	ASC2HEX8	;AHilj
			mov	si,bx
		   .until	(!(Carry?))
		   mov	cDebug,ah
		.else
			JMP	OPTION_ERROR	;G[
		.endif

	.else
		les	di,ptFilename		;t@C|C^
		.if	(byte ptr es:[di] != 0)
			JMP	OPTION_ERROR	;t@CQĂ悧`
		.endif

		dec	si			;|C^߂
		mov	dotFlag,0
		.while	(cx>=si)
			lodsb
			.if	(al == '.')
				mov	dotFlag,1
			.elseif	(al < 21h)
				dec	si
				.break		;21hIB
			.endif
			stosb			;t@CZbg
		.endw

		.if	(dotFlag==0)		;gq`Ȃ`
			mov	al,'.'
			stosb
			mov	al,'M'		;".MML"ɂBꉞA啶ŁB
			stosb
			mov	al,'M'
			stosb
			mov	al,'L'
			stosb
		.endif

		mov	al,0			;
		stosb
		mov	al,24h			;
		stosb
	.endif

    .endw

	;-----------------------
	;tOɉ
	;fobO
	.if	(cDebug != 0)
		mov	al,cDebug
		mov	CS:[D_Debug],AL		;ݒ
	.endif

	;wv
	.if	(cHelp != 0)
		jmp	OPTION_HELP		;
	.endif

	;t@C
	les	di,ptFilename			;t@C|C^
	.if	(byte ptr es:[di] != 0)
		invoke	Change_Current_Directory,	addr es:[di]

		;I[v
		invoke	File_Open,			addr es:[di],	0
		mov	word ptr cs:[hMml_File],ax
		push	ax

		;[h
		mov	ds,word ptr CS:[segMml_File]
		xor	bx,bx			;
		mov	ds:[bx],0a0dh		;t@C擪ɉs}
		invoke	File_Load,	ax,addr ds:2
		add	ax,2			;
		mov	word ptr CS:[szMml_File],ax

		;N[Y
		pop	ax
		invoke	File_Close,	ax
	.else
		jmp	OPTION_HELP	;t@C̎w肪΁A
	.endif

	popa
	RET				;RETURN
Op_	endp
;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				MML Compiler Program			|
;				Main Routine				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;WX^gp								|
;	ds	WTDt@CׂɊmۂEZOg	|
;	es	MMLt@CׂɊmۂEZOg	|
;	ax	Z[up̃t@Cnh				|
;=======================================================================|
.code
_main	proc	near

	local	Ext[3]:BYTE		;gq@ύXp
	local	cFilename[134]:BYTE	;t@C

	;-------------------------------
	;I[v
	invoke	Memory_Open,	01000h	;
	mov	word ptr cs:[segMml_File],ax
	mov	es,ax			;ESMML SEGMENT
	invoke	Memory_Open,	01000h	;
	mov	word ptr cs:[segWtd_File],ax
	mov	ds,ax			;DSWTD SEGMENT

	;-------------------------------
	;IvV
	invoke	Op_,	addr ss:cFilename	;IvVɋLqꂽt@C擾B

	;-------------------------------
	;RpC
	invoke	c_Head_first		;wb_[  CN[ht@C̑}
	invoke	c_voice			;F]
	invoke	c_Command		;p[gRpC
	invoke	c_Head_end		;wb_[ݒ(ԍŌɌĂԁB)

	;-------------------------------
	;WTD or FX t@C̃Z[u
	;Z[ut@C̍쐬
	.if	(cs:[cHCD_FlagFx]==00h)
		mov	Ext[0],'W'		;
		mov	Ext[1],'T'		;gq"WTD"
		mov	Ext[2],'D'		;
	.else
		mov	Ext[0],'F'		;
		mov	Ext[1],'X'		;gq"FX"
		mov	Ext[2],0		;
	.endif
	invoke	ChangeExt,	addr ss:cFilename,addr ss:Ext
	invoke	File_Create,	addr ss:cFilename,0
	mov	word ptr cs:[hWtd_File],ax

	;Z[uEt@C֏
	.if	(cs:[cHCD_FlagFx]!=00h)
	   invoke  File_Write,	ax,128,addr cs:FX
	.endif
	invoke	File_Write,	ax,word ptr cs:[pWTD_File],addr ds:0
	invoke	File_Close,	ax

	;-------------------------------
	;fobNpZ[u
	.if	(CS:[D_Debug] & 80h)
		mov	Ext[0],'T'		;
		mov	Ext[1],'C'		;gq"TCM"
		mov	Ext[2],'M'		;
		invoke	ChangeExt,	addr ss:cFilename,addr ss:Ext
		invoke	File_Create,	addr ss:cFilename,0
		invoke	File_Write,	ax,word ptr cs:[szMml_File],addr es:0
		invoke	File_Close,	ax
	.endif

	;-------------------------------
	;̉
	invoke	Memory_Close,	ds
	invoke	Memory_Close,	es

	ret
_main	endp
;************************************************************************
;*		I							*
;************************************************************************
	END

