;=======================================================================|
;									|
;		Wander Swan Total Sound Driver				|
;				Sound Control				|
;									|
;					Programmed by			|
;						A.Watanabe		|
;									|
;=======================================================================|
;****************************************************************
;*								*
;*		v@r@obl		*
;*								*
;****************************************************************
;===============================================================|
;			I/O Address				|
;===============================================================|
PCM_Com_Frection	equ	080h			;g
PCM_Com_FrectionCh1	equ	PCM_Com_Frection + 0	;g
PCM_Com_FrectionCh2	equ	PCM_Com_Frection + 2	;g
PCM_Com_FrectionCh3	equ	PCM_Com_Frection + 4	;g
PCM_Com_FrectionCh4	equ	PCM_Com_Frection + 6	;g
PCM_Com_Volume		equ	088h			;
PCM_Com_VolumeCh1	equ	PCM_Com_Volume + 0	;
PCM_Com_VolumeCh2	equ	PCM_Com_Volume + 1	;
PCM_Com_VolumeCh3	equ	PCM_Com_Volume + 2	;
PCM_Com_VolumeCh4	equ	PCM_Com_Volume + 3	;
PCM_Com_PCMVoice	equ	Pcm_Com_VolumeCh2	;PCM Voice
PCM_Com_Sweep		equ	08Ch			;Sweep
PCM_Com_SweepLevel	equ	PCM_Com_Sweep + 0	;Sweep Level
PCM_Com_SweepTime	equ	PCM_Com_Sweep + 1	;Sweep time
PCM_Com_Noise		equ	08Eh			;Noise mode
PCM_Com_VoiceAddress	equ	08Fh			;FWave table address
PCM_Com_Channel		equ	090h			;Channel mode
PCM_Com_Output		equ	091h			;Output mode
PCM_Com_Random		equ	092h			;Random get
PCM_Com_VolumePCM	equ	094h			;PCM Voice Volume
PCM_Com_VoiceCtrl	equ	095h			;PCM Voice Control
;===============================================================|
;			Work Address				|
;===============================================================|
;PCM_Wrok_Segment	equ	0000h	;FreyaBIOS Work Area
;PCM_Wrok_VoiceTable	equ	0180h	;FreyaBIOS Work Area
;===============================================================|
;			萔					|
;===============================================================|
PCM_Channel_mask	equ	0300h	;}XN
PcmVoiceMode_Set	equ	2020h	;Channel Mode  PCM Voice Mode Set
PcmVoiceMode_Reset	equ	2000h	;Channel Mode  PCM Voice Mode Reset
;===============================================================|
;		TEh̏				|
;===============================================================|
;								|
;		ds:[si]	ʍ\				|
;	Ԃl							|
;								|
;								|
;		devicȅ					|
;===============================================================|
	even				;AhXzu
SP_init	proc near			;
	push	ax			;
	push	cx			;
	push	di			;
	push	es			;WX^ۑ

	mov	ax,ds:[si].WTD_Sys_VoiceTableOffset
	call	SP_Set_VoiceAdd		;Fe[u̐ݒ

	push	IRAM_Segment		;
	pop	es			;
	mov	di,ax			;es:di0000h:0180h

	xor	ax,ax			;efoCX̏
	mov	cx,0020h		;64byte]
	rep	stosw			;F̏
	xor	ax,ax			;
	out	PCM_Com_VolumeCh1,al	;
	out	PCM_Com_VolumeCh2,al	;
	out	PCM_Com_VolumeCh3,al	;
	out	PCM_Com_VolumeCh4,al	;
	out	PCM_Com_SweepLevel,al	;
	out	PCM_Com_SweepTime,al	;
	out	PCM_Com_Noise,al	;
	mov	al,00fh			;
	out	PCM_Com_Channel,al	;
	mov	al,00fh			;
	out	PCM_Com_Output,al	;
	out	PCM_Com_VolumePCM,al	;
	mov	ax, 07FFh
	out	PCM_Com_FrectionCh1,ax	;
	out	PCM_Com_FrectionCh2,ax	;
	out	PCM_Com_FrectionCh3,ax	;
	out	PCM_Com_FrectionCh4,ax	;

;		to do	WSC check
;	mov	al,0FFh			;
;	out	PCM_Com_VoiceCtrl,al	;

	pop	es			;WX^A
	pop	di			;
	pop	cx			;
	pop	ax			;
	ret				;
SP_init	endp				;
;===============================================================|
;			g̃Zbg				|
;===============================================================|
;								|
;		CH	Channel					|
;		AX	Frection				|
;	Ԃl							|
;								|
;								|
;		g̃Zbg					|
;===============================================================|
	even				;AhXzu
SP_Set_Frection	proc near		;
	push	cx			;
	push	dx			;WX^ۑ

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Frection_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Frection_End	;ʉĂ邩H

SP_Set_Frection_Step:			;
	mov	dx,PCM_Com_Frection	;dxI/O Address base
	and	cx,PCM_Channel_mask	;
	shr	cx,7			;cx = ch * 2
	add	dx,cx			;dxI/O Address
	out	dx,ax			;out(dx),ax

SP_Set_Frection_End:			;
	pop	dx			;WX^A
	pop	cx			;
	ret				;
SP_Set_Frection	endp			;
;===============================================================|
;			ʂ̃Zbg				|
;===============================================================|
;								|
;		CH	Channel					|
;		AL	Volume					|
;	Ԃl							|
;								|
;								|
;		ʂ̃Zbg					|
;===============================================================|
	even				;AhXzu
SP_Set_Volume	proc near		;
	push	cx			;
	push	dx			;WX^ۑ

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Volume_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Volume_End	;ʉĂ邩H

SP_Set_Volume_Step:			;
	mov	dx,PCM_Com_Volume	;dxI/O Address base
	and	cx,PCM_Channel_mask	;
	shr	cx,8			;cx = cl
	add	dx,cx			;dxI/O Address
	out	dx,al			;out(dx),ax

SP_Set_Volume_End:			;
	pop	dx			;WX^A
	pop	cx			;
	ret				;
SP_Set_Volume	endp			;
;===============================================================|
;			XEB[ṽZbg			|
;===============================================================|
;								|
;		AL	Sweep Level				|
;		AH	Sweep Time				|
;	Ԃl							|
;								|
;								|
;		XEB[v̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_Sweep	proc near		;
	push	dx

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Sweep_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Sweep_End	;ʉĂ邩H

SP_Set_Sweep_Step:			;
	out	PCM_Com_SweepLevel,al	;o
	xchg	al,ah			;
	out	PCM_Com_SweepTime,al	;o
	xchg	al,ah			;

SP_Set_Sweep_End:			;
	pop	dx			;
	ret				;
SP_Set_Sweep	endp			;
;===============================================================|
;			mCY[h̃Zbg			|
;===============================================================|
;								|
;		AL	Set Data				|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		mCY[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_Noise	proc near		;
	push	dx			;WX^̕ۑ

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Noise_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Noise_End	;ʉĂ邩H

SP_Set_Noise_Step:			;
	mov	dx,PCM_Com_Noise	;dxI/O Address
	call	SP_Set_with_mask	;

SP_Set_Noise_End:			;
	pop	dx			;
	ret				;WX^̕A
SP_Set_Noise	endp			;
;===============================================================|
;			Channel mode̐ݒ			|
;===============================================================|
;								|
;		AL	Channel mode				|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		`l[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_Channel	proc near		;
	push	dx			;WX^̕ۑ

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Channel_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Channel_End	;ʉĂ邩H

SP_Set_Channel_Step:			;
	mov	dx,PCM_Com_Channel	;dxI/O Address
	call	SP_Set_with_mask	;

SP_Set_Channel_End:			;
	pop	dx			;
	ret				;WX^̕A
SP_Set_Channel	endp			;
;===============================================================|
;			F̐ݒ				|
;===============================================================|
;								|
;		CH	`l				|
;		DS:SI	Ff[^̃AhX			|
;	Ԃl							|
;								|
;								|
;		Fݒ肷					|
;===============================================================|
	even				;AhXzu
SP_Set_Voice	proc	near		;
	push	cx			;
	push	dx			;
	push	di			;
	push	si			;
	push	es			;WX^ۑ

	test	ds:[di].WTD_FlagControl,WTD_Ctrl_Effect
	jnz	SP_Set_Voice_Step	;ʉp[gH
	mov	cl,ch			;
	inc	cl			;
	mov	dx,00800h		;
	shl	dx,cl			;
	test	ds:[bp].WTD_WorkAdd_System+WTD_Sys_Flag,dx
	jnz	SP_Set_Voice_End	;ʉĂ邩H

SP_Set_Voice_Step:			;

	cld				;CNg[h

	push	IRAM_Segment		;es0000h
	pop	es			;
;	mov	di,PCM_Wrok_VoiceTable	;0180h(Fe[uAhX)
	mov	di,ds:[bp].WTD_WorkAdd_System+WTD_Sys_VoiceTableOffset
	and	cx,PCM_Channel_mask	;
	shr	cx,4			;
	add	di,cx			;es:di0000h:0180h + ch ~ 16
	mov	cx,8			;16byte]B
	rep	movsw			;]

SP_Set_Voice_End:			;
	pop	es			;WX^A
	pop	si			;
	pop	di			;
	pop	dx
	pop	cx			;
	ret				;
SP_Set_Voice	endp			;
;***************************************************************
;*			VXe				*
;***************************************************************
;===============================================================|
;			Fe[ũAhX			|
;===============================================================|
;								|
;		AX	Address					|
;	Ԃl							|
;								|
;								|
;		Fe[ũAhXݒ			|
;===============================================================|
	even				;AhXzu
SP_Set_VoiceAdd	proc near	uses ax	;
	shr	ax,6			;64BytePʁB64ŊB
	out	PCM_Com_VoiceAddress,al	;o
	ret				;
SP_Set_VoiceAdd	endp			;
;===============================================================|
;			Channel mode̎擾			|
;===============================================================|
;								|
;								|
;	Ԃl							|
;		AX	Channel mode(ah = 00h)			|
;								|
;		`l[h̎擾				|
;===============================================================|
	even				;AhXzu
SP_Get_Channel	proc near		;
	xor	ax,ax			;
	in	al,PCM_Com_Channel	;
	ret				;
SP_Get_Channel	endp			;
;===============================================================|
;			Output mode̐ݒ			|
;===============================================================|
;								|
;		AL	Output mode				|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		o̓[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_Output	proc near	uses dx	;
	mov	dx,PCM_Com_Output	;dxI/O Address
	call	SP_Set_with_mask	;
	ret				;WX^̕A
SP_Set_Output	endp			;
;===============================================================|
;			Output mode̎擾			|
;===============================================================|
;								|
;								|
;	Ԃl							|
;		AX	Output mode (AH = 0)			|
;								|
;		o̓[h̎擾				|
;===============================================================|
	even				;AhXzu
SP_Get_Output	proc near		;
	xor	ax,ax			;
	in	al,PCM_Com_Output	;
	ret				;
SP_Get_Output	endp			;
;===============================================================|
;			^̎擾				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;		AX	^				|
;								|
;		^̎擾					|
;===============================================================|
	even				;AhXzu
SP_Get_Random	proc near		;
	in	ax,PCM_Com_Random	;
	ret				;
SP_Get_Random	endp			;
;===============================================================|
;			PCM Volume Volume̐ݒ			|
;===============================================================|
;								|
;		AL	PCM Voice Volume			|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		o̓[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_VolumePCM	proc near	uses dx
	mov	dx,PCM_Com_VolumePCM	;dxI/O Address
	call	SP_Set_with_mask	;
	ret				;WX^̕A
SP_Set_VolumePCM	endp		;
;===============================================================|
;			PCM Volume Volume̐ݒ			|
;===============================================================|
;								|
;		AL	PCM Voice Volume			|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		o̓[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Get_VolumePCM	proc near	;
	in	al,PCM_Com_VolumePCM	;
	ret				;
SP_Get_VolumePCM	endp		;

;===============================================================|
;			PCM Volume Volume̐ݒ			|
;===============================================================|
;								|
;		AL	PCM Voice Volume			|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		o̓[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Set_PCMVoice		proc near	uses dx
	mov	dx,PCM_Com_VoiceCtrl	;dxI/O Address
	call	SP_Set_with_mask	;
	ret				;WX^̕A
SP_Set_PCMVoice		endp		;
;===============================================================|
;			PCM Volume Volume̐ݒ			|
;===============================================================|
;								|
;		AL	PCM Voice Volume			|
;		AH	Set bit					|
;	Ԃl							|
;								|
;								|
;		o̓[h̐ݒ				|
;===============================================================|
	even				;AhXzu
SP_Get_PCMVoice	proc near		;
	in	al,PCM_Com_VoiceCtrl	;
	ret				;
SP_Get_PCMVoice	endp			;

;---------------------------------------------------------------|
;		}XN𗘗pĈꕔo			|
;---------------------------------------------------------------|
;	dx		i/o address				|
;	al		set data				|
;	ah		set bit					|
;---------------------------------------------------------------|
	even				;AhXzu
SP_Set_with_mask	proc	near	uses ax cx

	and	al,ah			;}XN
	mov	cl,al			;chSet Data
	not	ah			;}XNf[^̔]
	in	al,dx			;
	and	al,ah			;}XN
	or	al,cl			;_a
	out	dx,al			;o

	ret				;
SP_Set_with_mask	endp
;****************************************************************
;*								*
;*			lhch				*
;*				JIS X 6054-1			*
;*				JIS X 6054-2 Q		*
;*								*
;****************************************************************
ifndef	hyoka
;===============================================================|
;			R}h				|
;===============================================================|
MIDI_Com_KeyOff		equ	080h	;
MIDI_Com_KeyOn		equ	090h	;
MIDI_Com_KeyPress	equ	0A0h	;
MIDI_Com_Control	equ	0B0h	;
MIDI_Com_Program	equ	0C0h	;
MIDI_Com_ChPress	equ	0D0h	;
MIDI_Com_PitchBend	equ	0E0h	;
MIDI_Com_Exclucive	equ	0F0h	;
;===============================================================|
;			Rg[R[h			|
;===============================================================|
MIDI_Ctrl_MSB		equ	20h	;
MIDI_Ctrl_Bank		equ	00h	;
MIDI_Ctrl_Mod		equ	01h	;
MIDI_Ctrl_Bress		equ	02h	;
MIDI_Ctrl_Foot		equ	04h	;
MIDI_Ctrl_PolTime	equ	05h	;
MIDI_Ctrl_DataEntly	equ	06h	;
MIDI_Ctrl_Volume	equ	07h	;
MIDI_Ctrl_Blance	equ	08h	;
MIDI_Ctrl_Pan		equ	0Ah	;
MIDI_Ctrl_Expression	equ	0Bh	;
MIDI_Ctrl_Effect1	equ	0Ch	;
MIDI_Ctrl_Effect2	equ	0Dh	;
MIDI_Ctrl_Hold		equ	40h	;
MIDI_Ctrl_PolSW		equ	41h	;|^gXCb`
MIDI_Ctrl_S		equ	42h	;\k[e[g
MIDI_Ctrl_Soft		equ	43h	;\tgy_
MIDI_Ctrl_Legert	equ	44h	;K[gXCb`
MIDI_Ctrl_Hold2		equ	45h	;z[h
MIDI_Ctrl_PolControl	equ	54h	;|^gRg[
MIDI_Ctrl_Reverv	equ	5Bh	;o[u
MIDI_Ctrl_Tremono	equ	5Ch	;gm
MIDI_Ctrl_Chorus	equ	5Dh	;R[X
MIDI_Ctrl_Delay		equ	5Eh	;fBC
MIDI_Ctrl_F		equ	5Fh	;tFU[
MIDI_Ctrl_DataInc	equ	60h	;
MIDI_Ctrl_DaraDec	equ	61h	;
MIDI_Ctrl_NonRegLSB	equ	62h	;fBC
MIDI_Ctrl_NonRegMSB	equ	63h	;tFU[
MIDI_Ctrl_RegLSB	equ	64h	;
MIDI_Ctrl_RegMSB	equ	65h	;
;===============================================================|
;			WX^[hp[^			|
;===============================================================|
;				LSB-MSB
MIDI_Reg_PitchBend	equ	0000h	;sb`xhZVeBreB
MIDI_Reg_Fain		equ	0001h	;t@C`[
MIDI_Reg_Cose		equ	0002h	;R[X`[
MIDI_Reg_CProgram	equ	0003h	;`[jOvOZNg
MIDI_Reg_CBank		equ	0004h	;`[jOoNZNg
MIDI_Reg_NULL		equ	7F7Fh	;k
;===============================================================|
;			萔					|
;===============================================================|
MIDI_Channel_mask	equ	0Fh	;}XN
;===============================================================|
;			GNXN[Vu			|
;===============================================================|
	even				;AhXzu
MIDI_Ex_GmReset		db	6,0f0h,7eh,7fh,09h,01h,0f7h
MIDI_Ex_GsReset		db	0
MIDI_Ex_XgReset		db	0
;===============================================================|
;			MIDI Running Status			|
;===============================================================|
;								|
;		al	MIDI Command				|
;	Ԃl							|
;								|
;								|
;		jOEXe[^XlR}hM	|
;===============================================================|
SM_Send_With_Running_Status:		;
	cmp	ds:[bp].WTD_WorkAdd_System+WTD_Sys_RunningStatus,al
	jz	SM_Send_With_Running_Status_e
	call	C_Send			;R}h̑M
	mov	ds:[bp].WTD_WorkAdd_System+WTD_Sys_RunningStatus,al
SM_Send_With_Running_Status_e:		;
	ret				;
;===============================================================|
;			MIDȈ				|
;===============================================================|
;								|
;								|
;	Ԃl							|
;								|
;								|
;			GM Reset̑M				|
;===============================================================|
	even				;AhXzu
SM_init	proc near			;
	push	cx			;
	push	si			;
	push	es			;WX^ۑ

	push	cs			;
	pop	es			;dscs
	xor	cx,cx			;cxMIDI_Ex_GmReset
	mov	cl,byte ptr es:[MIDI_Ex_GmReset]
	mov	si,offset CGROUP:MIDI_Ex_GmReset + 1
	call	C_Send_Block		;ubNM

	;jOXe[^X̏
	mov	ds:[si].WTD_Sys_RunningStatus,0

	pop	es			;WX^A
	pop	si			;
	pop	cx			;
	ret				;
SM_init	endp				;
;===============================================================|
;			KeyOff					|
;===============================================================|
;								|
;		CH	Track					|
;		AL	Key					|
;	Ԃl							|
;		AH	00h					|
;								|
;		KeyOff						|
;===============================================================|
	even				;AhXzu
SM_KeyOff:				;
	xor	ah,ah			;~(KeyOff)
;===============================================================|
;			KeyOn					|
;===============================================================|
;								|
;		CH	Track					|
;		AH	Velocity (0:KeyOff)			|
;		AL	Key					|
;	Ԃl							|
;								|
;								|
;		KeyOn						|
;===============================================================|
	even				;AhXzu
SM_KeyOn	proc near		;
	push	cx			;WX^ۑ

	push	ax			;WX^ۑ
	mov	al,MIDI_Com_KeyOn	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	pop	ax			;WX^A
	call	C_Send_Word		;f[^̑M

	pop	cx			;WX^A
	ret				;
SM_KeyOn	endp			;
;===============================================================|
;			Poly Key Press				|
;===============================================================|
;								|
;		CH	Track					|
;		AH	Pressior				|
;		AL	Key					|
;	Ԃl							|
;								|
;								|
;		L[vbV[iAt^[^b`j̑M	|
;===============================================================|
	even				;AhXzu
SM_KeyPress	proc near		;
	push	cx			;WX^ۑ

	push	ax			;WX^ۑ
	mov	al,MIDI_Com_KeyPress	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	pop	ax			;WX^A
	call	C_Send_Word		;f[^̑M

	pop	cx			;WX^A
	ret				;
SM_KeyPress	endp			;
;===============================================================|
;			Control Change Byte			|
;===============================================================|
;								|
;		CH	Track					|
;		CL	Reg.					|
;		AL	Data					|
;	Ԃl							|
;								|
;								|
;		Control Change					|
;===============================================================|
	even				;AhXzu
SM_ControlByte	proc near		;
	push	ax			;
	push	cx			;WX^ۑ

	push	ax			;ۑ
	mov	al,MIDI_Com_Control	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	pop	ax			;A
	mov	ah,al			;
	mov	al,cl			;
	call	C_Send_Word		;f[^̑M

	pop	cx			;WX^A
	pop	ax			;
	ret				;
SM_ControlByte	endp			;
;===============================================================|
;			Control Change Word			|
;===============================================================|
;								|
;		CH	Track					|
;		CL	Reg.					|
;		AX	Data					|
;	Ԃl							|
;								|
;								|
;		Control Change					|
;===============================================================|
	even				;AhXzu
SM_ControlWord	proc near		;
	push	ax			;
	push	cx			;WX^ۑ

	shl	ax,1			;
	shr	al,1			;
	and	ax,07f7fh		;f[^̕

	push	ax			;ۑ
	mov	al,MIDI_Com_Control	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	pop	ax			;A
	push	ax			;
	mov	al,cl			;
	call	C_Send_Word		;WX^(ah)Cf[^̑M(ah(LSB))
	pop	ax			;A
	mov	ah,al			;
	mov	al,cl			;
	add	al,MIDI_Ctrl_MSB	;
	call	C_Send_Word		;WX^(ah)Cf[^̑M(al(MSB))

	pop	cx			;WX^A
	pop	ax			;
	ret				;
SM_ControlWord	endp			;
;===============================================================|
;			Program Change				|
;===============================================================|
;								|
;		CH	Track					|
;		AL	Program					|
;	Ԃl							|
;								|
;								|
;		Program Change					|
;===============================================================|
	even				;AhXzu
SM_Program	proc near		;
	push	ax			;
	push	cx			;WX^ۑ

	mov	ah,al			;
	mov	al,MIDI_Com_Program	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	mov	al,ah			;
	call	C_Send			;f[^̑M

	pop	cx			;WX^A
	pop	ax			;
	ret				;
SM_Program	endp			;
;===============================================================|
;			Program Change with Bank		|
;===============================================================|
;								|
;		CH	Track					|
;		AL	Program					|
;		BX	Bank(AH:Msb,AL:Lsb)			|
;	Ԃl							|
;								|
;								|
;		Program ChangeBank Select̑M		|
;===============================================================|
	even				;AhXzu
SM_BankProgram	proc near		;
	push	cx			;WX^̕ۑ

	push	ax			;
	mov	cl,MIDI_Ctrl_Bank	;oNZNg
	mov	ax,bx			;oN
	shl	al,1			;
	shr	ax,1			;
	and	ax,03fffh		;f[^
	call	SM_ControlWord		;
	pop	ax			;
	call	SM_Program		;vO`FW
	
	pop	cx			;WX^̕A
	ret				;
SM_BankProgram	endp			;
;===============================================================|
;			Poly Ch Press				|
;===============================================================|
;								|
;		CH	Track					|
;		AL	Pressior				|
;	Ԃl							|
;								|
;								|
;		L[vbV[iAt^[^b`j̑M	|
;===============================================================|
	even				;AhXzu
SM_ChPress	proc near		;
	push	cx			;
	push	ax			;WX^ۑ

	mov	ah,al			;
	mov	al,MIDI_Com_KeyPress	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	mov	al,ah			;
	call	C_Send			;f[^̑M

	pop	ax			;WX^A
	pop	cx			;
	ret				;
SM_ChPress	endp			;
;===============================================================|
;			Pitch Bend				|
;===============================================================|
;								|
;		CH	Track					|
;		AX	Pitch Bend				|
;	Ԃl							|
;								|
;								|
;		Pitch Bend̑M				|
;===============================================================|
	even				;AhXzu
SM_PitchBend	proc near		;
	push	cx			;WX^ۑ

	push	ax			;WX^ۑ
	mov	al,MIDI_Com_PitchBend	;
	and	ch,MIDI_Channel_mask	;
	or	al,ch			;
	call	SM_Send_With_Running_Status	;R}h̑M
	pop	ax			;WX^A
	push	ax			;WX^ۑ
	shl	ax,1			;
	shr	al,1			;
	and	ax,07f7fh		;f[^̕
	call	C_Send_Word		;f[^̑M
	pop	ax			;WX^A

	pop	cx			;WX^A
	ret				;
SM_PitchBend	endp			;
;===============================================================|
endif
