;***********************************************************************
;*		Wonder Witch program for C Magazine			
;*			Device Define file				
;*				Programed by A.Watanabe (S.W.)		
;***********************************************************************
;=========================================================================
;	VXe
;=========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
Hardware		equ	0A0h	; @픻ʗp 

;--------------------------------------
;	萔`
;--------------------------------------
;Status bit
HardwareMask		equ	002h	; @픻ʗp 

;========================================================================
;	
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
LCD_DisplayControl	equ	000h	;  
LCD_Line		equ	002h	; Gf[^̃C 
LCD_Interrupt		equ	003h	; 荞݂郉C 
LCD_SpriteArea		equ	004h	; SpriteVRAM 
LCD_SpriteStart		equ	005h	; \XvCg̍ŏ̔ԍ 
LCD_SpriteCount		equ	006h	; \XvCg̐ 
LCD_ScreenArea		equ	007h	; ScreenVRAM 
LCD_Scr2WindowsStart	equ	008h	; Screen2 Window̍̍W[dot] 
LCD_Scr2WindowsEnd	equ	00Ah	; Screen2 Window̉E̍W[dot] 
LCD_SprWindowsStart	equ	00Ch	; Sprite  Window̍̍W[dot] 
LCD_SprWindowsEnd	equ	00Eh	; Sprite  Window̉E̍W[dot] 
LCD_Scr1Scroll		equ	010h	; Screen1̃XN[ 
LCD_Scr2Scroll		equ	012h	; Screen2̃XN[ 
LCD_IF_Ctrl		equ	014h	; IFRg[ 
LCD_Segment		equ	015h	; ZOgE}[N 
LCD_Gray0123		equ	01Ch	; mN8K 0`3 
LCD_Gray4567		equ	01Eh	; mN8K 4`7 
LCD_ScrPalette		equ	020h	; mNpbg 
LCD_ScrPalette0		equ	LCD_ScrPalette + 000h
LCD_ScrPalette1		equ	LCD_ScrPalette + 002h
LCD_ScrPalette2		equ	LCD_ScrPalette + 004h
LCD_ScrPalette3		equ	LCD_ScrPalette + 006h
LCD_ScrPalette4		equ	LCD_ScrPalette + 008h
LCD_ScrPalette5		equ	LCD_ScrPalette + 00Ah
LCD_ScrPalette6		equ	LCD_ScrPalette + 00Bh
LCD_ScrPalette7		equ	LCD_ScrPalette + 00Ch
LCD_ScrPalette8		equ	LCD_ScrPalette + 010h
LCD_ScrPalette9		equ	LCD_ScrPalette + 012h
LCD_ScrPaletteA		equ	LCD_ScrPalette + 014h
LCD_ScrPaletteB		equ	LCD_ScrPalette + 016h
LCD_ScrPaletteC		equ	LCD_ScrPalette + 018h
LCD_ScrPaletteD		equ	LCD_ScrPalette + 01Ah
LCD_ScrPaletteE		equ	LCD_ScrPalette + 01Ch
LCD_ScrPaletteF		equ	LCD_ScrPalette + 01Eh
LCD_ColorMode		equ	060h	; J[[h 

;Memory Address			; X^[gEAbv[`ł̐ݒl 
VramAdrFontMono		equ	02000h		; Mono  FontVRAMAhX 
VramAdrFontColor	equ	04000h		; Color FontVRAMAhX 
VramAdrPalette		equ	0fe00h		; Palettte  VRAMAhX 

; AscIIP [h 
VramAdrSprite_a1	equ	02e00h		; Sprite    VRAMAhX 
VramAdrScreen1_a1	equ	03000h		; Screen    VRAMAhX 
VramAdrScreen2_a1	equ	03000h		; Screen    VRAMAhX 
; AscIIQ [h 
VramAdrSprite_a2	equ	02600h		; Sprite    VRAMAhX 
VramAdrScreen1_a2	equ	03000h		; Screen    VRAMAhX 
VramAdrScreen2_a2	equ	02800h		; Screen    VRAMAhX 
; {P [h 
VramAdrSprite_j1	equ	01600h		; Sprite    VRAMAhX 
VramAdrScreen1_j1	equ	01800h		; Screen    VRAMAhX 
VramAdrScreen2_j1	equ	01800h		; Screen    VRAMAhX 
; {Q [h 
VramAdrSprite_j2	equ	00e00h		; Sprite    VRAMAhX 
VramAdrScreen1_j2	equ	01000h		; Screen    VRAMAhX 
VramAdrScreen2_j2	equ	01800h		; Screen    VRAMAhX 
; IWi [h 
VramAdrSprite_sc	equ	02e00h		; Sprite    VRAMAhX 
VramAdrScreen1_sc	equ	03000h		; Screen    VRAMAhX 
VramAdrScreen2_sc	equ	03800h		; Screen    VRAMAhX 

ifdef DISPLAY_MODE_ASCII1		; AscIIP [h 
VramAdrSprite		equ	VramAdrSprite_a1	; SpriteVRAMAhX 
VramAdrScreen1		equ	VramAdrScreen1_a1	; ScreenVRAMAhX 
VramAdrScreen2		equ	VramAdrScreen2_a1	; ScreenVRAMAhX 
endif
ifdef DISPLAY_MODE_ASCII2		; AscIIQ [h 
VramAdrSprite		equ	VramAdrSprite_a2	; SpriteVRAMAhX 
VramAdrScreen1		equ	VramAdrScreen1_a2	; ScreenVRAMAhX 
VramAdrScreen2		equ	VramAdrScreen2_a2	; ScreenVRAMAhX 
endif
ifdef DISPLAY_MODE_JAPANESE1	; {P [h 
VramAdrSprite		equ	VramAdrSprite_j1	; SpriteVRAMAhX 
VramAdrScreen1		equ	VramAdrScreen1_j1	; ScreenVRAMAhX 
VramAdrScreen2		equ	VramAdrScreen2_j1	; ScreenVRAMAhX 
endif
ifdef DISPLAY_MODE_JAPANESE2	; {Q [h 
VramAdrSprite		equ	VramAdrSprite_j2	; SpriteVRAMAhX 
VramAdrScreen1		equ	VramAdrScreen1_j2	; ScreenVRAMAhX 
VramAdrScreen2		equ	VramAdrScreen2_j2	; ScreenVRAMAhX 
endif
ifdef DISPLAY_MODE_swCOLOR		; IWi [h 
VramAdrSprite		equ	VramAdrSprite_sc	; SpriteVRAMAhX 
VramAdrScreen1		equ	VramAdrScreen1_sc	; ScreenVRAMAhX 
VramAdrScreen2		equ	VramAdrScreen2_sc	; ScreenVRAMAhX 
endif

;--------------------------------------
;	萔`
;--------------------------------------
;Agr[gp
Atr_Character		equ	001FFh		; LN^[ԍ(0`511) 
Atr_Palette		equ	01E00h		; pbg 
Atr_CharacterH		equ	02000h		; LN^[ԍ( + 512) 
Atr_Vm			equ	04000h		; ] 
Atr_Hm			equ	08000h		; c] 

;I/O Display Controlp
LCD_DispCtrl_Scr1	equ	00001h		; Screen1 Enable 
LCD_DispCtrl_Scr2	equ	00002h		; Screen2 Enable 
LCD_DispCtrl_Spr	equ	00004h		; Sprite  Enable 
LCD_DispCtrl_SprWin	equ	00008h		; Sprite  Windows Enable 
LCD_DispCtrl_ScrWin	equ	00030h		; Screen2 Windows Mode 
LCD_DispCtrl_BCol	equ	00F00h		; {[_[ Color 
LCD_DispCtrl_BPal	equ	0F000h		; {[_[ Palette 

;I/O LCD Segmentp
LCD_Segment_Sleep	equ	001h		; Sleep_ 
LCD_Segment_Hor		equ	002h		; c_ 
LCD_Segment_Ver		equ	004h		; _ 

;I/O Color modep
LCD_ColorModeMask	equ	01fh		; J[[ḧׂ̃}XNl 

;LCD֘A 
LCD_Sprite		equ	128		; XvCg 
LCD_ScrHight		equ	32		; VRAM̏cTCY 
LCD_ScrWidth		equ	32		; VRAM̉TCY 
LCD_Font		equ	1024		; tHg 
LCD_FontSizeMono	equ	16		; tHg̃TCY 
LCD_FontSize		equ	32		; tHg̃TCY 
LCD_Palette		equ	16		; pbg 
LCD_Color		equ	16		; Ppbgł̐F 
LCD_FontMono		equ	512		; F(2^2= 4) 
LCD_FontColor		equ	1024		; F(2^4=16) 
LCD_FontHight		equ	8		; tHg̏cTCY 
LCD_FontWidth		equ	8		; tHg̉TCY 

;========================================================================
;	TEh
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
SOUND_Frequency		equ	080h		; g 
SOUND_FrequencyCh1	equ	SOUND_Frequency + 0
SOUND_FrequencyCh2	equ	SOUND_Frequency + 2
SOUND_FrequencyCh3	equ	SOUND_Frequency + 4
SOUND_FrequencyCh4	equ	SOUND_Frequency + 6
SOUND_Volume		equ	088h		;  
SOUND_VolumeCh1		equ	SOUND_Volume + 0
SOUND_VolumeCh2		equ	SOUND_Volume + 1
SOUND_VolumeCh3		equ	SOUND_Volume + 2
SOUND_VolumeCh4		equ	SOUND_Volume + 3
SOUND_PCMVoice		equ	SOUND_VolumeCh2	; PCM Voice 
SOUND_Sweep		equ	08Ch		; Sweep 
SOUND_SweepLevel	equ	SOUND_Sweep + 0	; Sweep Level 
SOUND_SweepTime		equ	SOUND_Sweep + 1	; Sweep time 
SOUND_Noise		equ	08Eh		; Noise mode 
SOUND_VoiceAddress	equ	08Fh		; FWave address 
SOUND_Channel		equ	090h		; Channel mode 
SOUND_Output		equ	091h		; Output mode 
SOUND_Random		equ	092h		; Random get 
SOUND_VolumePCM		equ	094h		; PCM Voice Volume 

;Memory Address
SOUND_VoiceAdr		equ	00180h		; FreyaBIOS Work Area 

;--------------------------------------
;	萔`
;--------------------------------------
;mCY[h
SOUND_NoiseMode		equ	007h		; mCYE[h 
SOUND_NoiseReset	equ	008h		; JE^[EZbg 
SOUND_NoiseEnable	equ	010h		; Cl[uEXCb` 

;`l[h
SOUND_ChannelCh1	equ	001h		; Ch1 Enable 
SOUND_ChannelCh2	equ	002h		; Ch2 Enable 
SOUND_ChannelCh3	equ	004h		; Ch3 Enable 
SOUND_ChannelCh4	equ	008h		; Ch4 Enable 
SOUND_ChannelPcmVoice	equ	020h		; PCM Voice Enable 
SOUND_ChannelSweep	equ	040h		; Sweep Enable 
SOUND_ChannelNoise	equ	080h		; Noise Enable 

;o̓[h
SOUND_OutputSpkEn	equ	001h		; Xs[JEnable 
SOUND_OutputRange	equ	006h		; Xs[Jo̓W 
SOUND_OutputPhoneEn	equ	008h		; OXs[JEnable 
SOUND_OutputPhoneSw	equ	080h		; OXs[Jڑ`FbN 

;Channel
SOUND_ChannelMax	equ	4		; `l 

;e}XN
SOUND_FrequencyMask	equ	007FFh		; Range 
SOUND_VolumeMask	equ	00Fh		; Range 

;Fp
SOUND_VoiceSize		equ	16		; Fp[^̃TCY 

;========================================================================
;	^C}[
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
TIMER_Status		equ	0A2h	; Timer Status 
TIMER_MaxCountH		equ	0A4h	; Hblank Load Count 
TIMER_MaxCountV		equ	0A6h	; Vblank Load Count 
TIMER_CounterH		equ	0A8h	; Hblank Down Counter 
TIMER_CounterV		equ	0AAh	; Vblank Down Counter 

;--------------------------------------
;	萔`
;--------------------------------------
;Status bit
; Set 
Timer_H_Enable		equ	001h	; Hblank Int. Enable	(or) 
Timer_H_auto		equ	002h	; Vblank auto preset mode(or) 
Timer_V_Enable		equ	004h	; Vblank Int. Enable 	(or) 
Timer_V_auto		equ	008h	; Vblank auto preset mode(or) 
; Reset
Timer_H_Disable		equ	0FEh	; Hblank Int. Disable	(and) 
Timer_H_shot		equ	0FDh	; Vblank 1 shot mode	(and) 
Timer_V_Disable		equ	0FBh	; Vblank Int. Disable	(and) 
Timer_V_shot		equ	0F7h	; Vblank 1 shot mode	(and) 

;========================================================================
;	荞
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
Int_Vector		equ	0B0h	; 荞݃xN^ (֎~) 
Int_Enable		equ	0B2h	; 荞݉ۃtO 
Int_Type		equ	0B4h	; vĂ銄荞 
Int_Eoi			equ	0B6h	; End of Interrupt̔s 

;--------------------------------------
;	萔`
;--------------------------------------
;荞݃xNg
INT_HARDWARE_VECTOR_BASE	equ	028h

;荞ݔԍ`
SYS_INT_SENDREADY		equ	0	;VAMf[^GveB[
SYS_INT_KEY			equ	1	;L[荞
SYS_INT_CASETTE			equ	2	;JZbg荞
SYS_INT_RECEIVEREADY		equ	3	;VAMf[^fB[
SYS_INT_DISPLINE		equ	4	;`惉Cԍm荞
SYS_INT_VBLANK_COUNTUP		equ	5	;^C}[荞
SYS_INT_VBLANK			equ	6	;ԊJn
SYS_INT_HBLANK_COUNTUP		equ	7	;^C}[荞

INT_SENDREADY		equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_SENDREADY
INT_KEY_PUSH		equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_KEY
INT_CASETTE		equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_CASETTE
INT_RECEIVEREADY	equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_RECEIVEREADY
INT_DISPLINE		equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_DISPLINE
INT_VBLANK_COUNTUP	equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_VBLANK_COUNTUP
INT_VBLANK		equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_VBLANK
INT_HBLANK_COUNTUP	equ INT_HARDHAEW_VECTOR_BASE + SYS_INT_HBLANK_COUNTUP

;荞bit
; Set 
INT_CommSendSet		equ	001h	; Mf[^		(or) 
INT_KeySet		equ	002h	; L[荞		(or) 
INT_CasetteSet		equ	004h	; JZbg荞	(or) 
INT_CommReciSet		equ	008h	; Mf[^fB[	(or) 
INT_LCDlineSet		equ	010h	; LCDG惉Cm	(or) 
INT_VblankSet		equ	020h	; Vblank 		(or) 
INT_VblankStartSet	equ	040h	; VblankԊJn	(or) 
INT_HblankSet		equ	080h	; Hblank		(or) 
; Reset
INT_CommSendRes		equ	0FEh	; Mf[^		(and) 
INT_KeyRes		equ	0FDh	; L[荞		(and) 
INT_CasetteRes		equ	0FBh	; JZbg荞	(and) 
INT_CommReciRes		equ	0F7h	; Mf[^fB[	(and) 
INT_LCDlineRes		equ	0FFh	; LCDG惉Cm	(and) 
INT_VblankRes		equ	0DFh	; Vblank 		(and) 
INT_VblankStartRes	equ	0BFh	; VblankԊJn	(and) 
INT_HblankRes		equ	07Fh	; Hblank		(and) 

;========================================================================
;	VAʐM
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
COMM_DATA		equ	0B1h	; Send & Receive data 
COMM_STATUS		equ	0B3h	; Serial Status 

;--------------------------------------
;	萔`
;--------------------------------------
;Status bit
; Set 
COMM_Receive		equ	001h	; Mf[^LiMj	 
COMM_OverRun		equ	002h	; I[o[EG[		 
COMM_SendEmpty		equ	004h	; Mobt@iMj	 
COMM_OrReset		equ	020h	; I[o[EG[̃Zbg 
COMM_Baudrate38k	equ	040h	; {[[gi38400 [bps])	(or) 
COMM_Enable		equ	080h	; ʐMCl[u		(or) 
; Reset 
COMM_Baudrate9K		equ	0BFh	; {[[gi 9600 [bps])	(and) 
COMM_Disable		equ	07Fh	; ʐMfBZ[u		(and) 

;========================================================================
;	L[
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
KEY			equ	0B5h	; COMON & Key Data 

;--------------------------------------
;	萔`
;--------------------------------------
;Comon bit
KEY_GroupY		equ	010h	; Y1,Y2,Y3,Y4 
KEY_GroupX		equ	020h	; X1,X2,X3,X4 
KEY_GroupABS		equ	040h	; A,B,Start 

;========================================================================
;	oN
;========================================================================
;--------------------------------------
;	I/O Device
;--------------------------------------
;I/O Address
Bank_SramSelect		equ	0C1h	; SRAM Bank 
Bank_Rom1Select		equ	0C2h	; ROM1 Bank 
Bank_Rom2Select		equ	0C3h	; ROM2 Bank 
